structure complex_rationalTheory :> complex_rationalTheory =
struct
  val _ = if !Globals.print_thy_loads then print "Loading complex_rationalTheory ... " else ()
  open Type Term Thm
  infixr -->

  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  (*  Parents *)
  local open ratTheory
  in end;
  val _ = Theory.link_parents
          ("complex_rational",
          Arbnum.fromString "1511261358",
          Arbnum.fromString "450707")
          [("rat",
           Arbnum.fromString "1485050583",
           Arbnum.fromString "628797")];
  val _ = Theory.incorporate_types "complex_rational"
       [("complex_rational", 0)];

  val idvector = 
    let fun ID(thy,oth) = {Thy = thy, Other = oth}
    in Vector.fromList
  [ID("min", "fun"), ID("integer", "int"), ID("rat", "rat"),
   ID("pair", "prod"), ID("num", "num"),
   ID("complex_rational", "complex_rational"), ID("min", "bool"),
   ID("ind_type", "recspace"), ID("bool", "!"), ID("pair", ","),
   ID("bool", "/\\"), ID("num", "0"), ID("min", "="), ID("min", "==>"),
   ID("bool", "?"), ID("min", "@"), ID("integer", "ABS"),
   ID("arithmetic", "BIT1"), ID("ind_type", "BOTTOM"),
   ID("complex_rational", "COMPLEX_ADD"),
   ID("complex_rational", "COMPLEX_ADD_tupled"),
   ID("complex_rational", "COMPLEX_DIV"),
   ID("complex_rational", "COMPLEX_GE"),
   ID("complex_rational", "COMPLEX_GE_tupled"),
   ID("complex_rational", "COMPLEX_GT"),
   ID("complex_rational", "COMPLEX_GT_tupled"),
   ID("complex_rational", "COMPLEX_LE"),
   ID("complex_rational", "COMPLEX_LE_tupled"),
   ID("complex_rational", "COMPLEX_LT"),
   ID("complex_rational", "COMPLEX_LT_tupled"),
   ID("complex_rational", "COMPLEX_MULT"),
   ID("complex_rational", "COMPLEX_MULT_tupled"),
   ID("complex_rational", "COMPLEX_NEG"),
   ID("complex_rational", "COMPLEX_RATIONAL"),
   ID("complex_rational", "COMPLEX_RECIPROCAL"),
   ID("complex_rational", "COMPLEX_SUB"),
   ID("complex_rational", "COMPLEX_SUB_tupled"), ID("ind_type", "CONSTR"),
   ID("bool", "DATATYPE"), ID("complex_rational", "DIVIDES"),
   ID("pair", "FST"), ID("combin", "I"), ID("complex_rational", "IS_INT"),
   ID("bool", "LET"), ID("arithmetic", "MOD"), ID("arithmetic", "NUMERAL"),
   ID("integer", "Num"), ID("pair", "SND"), ID("bool", "TYPE_DEFINITION"),
   ID("relation", "WF"), ID("relation", "WFREC"), ID("arithmetic", "ZERO"),
   ID("bool", "\\/"), ID("complex_rational", "com_0"),
   ID("complex_rational", "com_1"),
   ID("complex_rational", "complex_rational_CASE"),
   ID("complex_rational", "complex_rational_size"), ID("gcd", "gcd"),
   ID("integer", "int_div"), ID("integer", "int_of_num"),
   ID("pair", "pair_CASE"), ID("rat", "rat_0"), ID("rat", "rat_1"),
   ID("rat", "rat_add"), ID("rat", "rat_ainv"), ID("rat", "rat_div"),
   ID("rat", "rat_dnm"), ID("rat", "rat_geq"), ID("rat", "rat_gre"),
   ID("rat", "rat_leq"), ID("rat", "rat_les"), ID("rat", "rat_mul"),
   ID("rat", "rat_nmr"), ID("rat", "rat_sub"),
   ID("complex_rational", "reduce"), ID("complex_rational", "reduced_dnm"),
   ID("complex_rational", "reduced_nmr"), ID("frac", "rep_frac"),
   ID("frac", "frac"), ID("rat", "rep_rat")]
  end;
  local open SharingTables
  in
  val tyvector = build_type_vector idvector
  [TYOP [1], TYOP [2], TYOP [0, 1, 0], TYOP [3, 0, 0], TYOP [0, 3, 3],
   TYOP [4], TYOP [5], TYOP [0, 6, 5], TYV "'a", TYOP [0, 1, 8],
   TYOP [0, 1, 9], TYOP [0, 10, 8], TYOP [0, 6, 11], TYOP [6],
   TYOP [0, 6, 13], TYOP [0, 0, 13], TYOP [0, 0, 15], TYOP [3, 6, 6],
   TYOP [0, 17, 6], TYOP [0, 6, 6], TYOP [0, 6, 19], TYOP [0, 1, 6],
   TYOP [0, 1, 21], TYOP [0, 17, 13], TYOP [0, 6, 14], TYOP [3, 1, 1],
   TYOP [7, 25], TYOP [0, 26, 13], TYOP [0, 17, 23], TYOP [0, 22, 13],
   TYOP [0, 6, 8], TYOP [0, 6, 26], TYOP [0, 14, 13], TYOP [0, 32, 13],
   TYOP [0, 24, 13], TYOP [0, 34, 13], TYOP [0, 10, 13], TYOP [0, 36, 13],
   TYOP [0, 27, 13], TYOP [0, 38, 13], TYOP [0, 15, 13], TYOP [0, 1, 13],
   TYOP [0, 41, 13], TYOP [0, 6, 17], TYOP [0, 6, 43], TYOP [0, 0, 3],
   TYOP [0, 0, 45], TYOP [0, 1, 25], TYOP [0, 1, 47], TYOP [0, 13, 13],
   TYOP [0, 13, 49], TYOP [0, 8, 13], TYOP [0, 8, 51], TYOP [0, 23, 13],
   TYOP [0, 23, 53], TYOP [0, 18, 13], TYOP [0, 18, 55], TYOP [0, 5, 13],
   TYOP [0, 5, 57], TYOP [0, 3, 13], TYOP [0, 3, 59], TYOP [0, 1, 41],
   TYOP [0, 26, 27], TYOP [0, 30, 13], TYOP [0, 63, 13], TYOP [0, 31, 13],
   TYOP [0, 65, 13], TYOP [0, 28, 13], TYOP [0, 67, 28], TYOP [0, 0, 0],
   TYOP [0, 5, 5], TYOP [0, 5, 26], TYOP [0, 71, 26], TYOP [0, 25, 72],
   TYOP [0, 5, 73], TYOP [0, 3, 0], TYOP [0, 45, 45], TYOP [0, 5, 70],
   TYOP [0, 0, 5], TYOP [0, 27, 65], TYOP [0, 23, 23], TYOP [0, 80, 23],
   TYOP [0, 28, 81], TYOP [0, 18, 18], TYOP [0, 83, 18], TYOP [0, 28, 84],
   TYOP [0, 61, 13], TYOP [0, 6, 86], TYOP [0, 22, 6], TYOP [0, 6, 88],
   TYOP [0, 0, 69], TYOP [0, 5, 0], TYOP [0, 17, 34], TYOP [0, 20, 6],
   TYOP [0, 17, 93], TYOP [0, 1, 1], TYOP [0, 1, 95], TYOP [78],
   TYOP [0, 97, 3], TYOP [0, 1, 97]]
  end
  val _ = Theory.incorporate_consts "complex_rational" tyvector
     [("reduced_nmr", 2), ("reduced_dnm", 2), ("reduce", 4),
      ("complex_rational_size", 7), ("complex_rational_CASE", 12),
      ("com_1", 6), ("com_0", 6), ("IS_INT", 14), ("DIVIDES", 16),
      ("COMPLEX_SUB_tupled", 18), ("COMPLEX_SUB", 20),
      ("COMPLEX_RECIPROCAL", 19), ("COMPLEX_RATIONAL", 22),
      ("COMPLEX_NEG", 19), ("COMPLEX_MULT_tupled", 18),
      ("COMPLEX_MULT", 20), ("COMPLEX_LT_tupled", 23), ("COMPLEX_LT", 24),
      ("COMPLEX_LE_tupled", 23), ("COMPLEX_LE", 24),
      ("COMPLEX_GT_tupled", 23), ("COMPLEX_GT", 24),
      ("COMPLEX_GE_tupled", 23), ("COMPLEX_GE", 24), ("COMPLEX_DIV", 20),
      ("COMPLEX_ADD_tupled", 18), ("COMPLEX_ADD", 20)];

  local open SharingTables
  in
  val tmvector = build_term_vector idvector tyvector
  [TMV("'complex_rational'", 27), TMV("COMPLEX_ADD_tupled", 18),
   TMV("COMPLEX_GE_tupled", 23), TMV("COMPLEX_GT_tupled", 23),
   TMV("COMPLEX_LE_tupled", 23), TMV("COMPLEX_LT_tupled", 23),
   TMV("COMPLEX_MULT_tupled", 18), TMV("COMPLEX_SUB_tupled", 18),
   TMV("M", 6), TMV("M'", 6), TMV("P", 14), TMV("P", 24), TMV("R", 28),
   TMV("a", 6), TMV("a", 17), TMV("a", 1), TMV("a0", 1), TMV("a0'", 1),
   TMV("a0'", 26), TMV("a1", 1), TMV("a1'", 1), TMV("a2", 1), TMV("b", 6),
   TMV("b", 1), TMV("b1", 1), TMV("b2", 1), TMV("c", 6), TMV("cc", 6),
   TMV("complex_rational", 29), TMV("f", 10), TMV("f'", 10), TMV("fn", 30),
   TMV("ia", 1), TMV("ib", 1), TMV("m", 0), TMV("n", 0), TMV("n", 5),
   TMV("r", 1), TMV("r0", 1), TMV("ra", 1), TMV("rb", 1), TMV("rep", 31),
   TMV("v", 6), TMV("v1", 6), TMV("x", 6), TMV("x", 0), TMV("x1", 6),
   TMV("y", 0), TMC(8, 32), TMC(8, 33), TMC(8, 35), TMC(8, 37), TMC(8, 39),
   TMC(8, 40), TMC(8, 42), TMC(8, 38), TMC(9, 44), TMC(9, 46), TMC(9, 48),
   TMC(10, 50), TMC(11, 5), TMC(12, 52), TMC(12, 50), TMC(12, 24),
   TMC(12, 54), TMC(12, 56), TMC(12, 16), TMC(12, 58), TMC(12, 60),
   TMC(12, 61), TMC(12, 62), TMC(13, 50), TMC(14, 64), TMC(14, 66),
   TMC(14, 42), TMC(15, 68), TMC(16, 69), TMC(17, 70), TMC(18, 26),
   TMC(19, 20), TMC(20, 18), TMC(21, 20), TMC(22, 24), TMC(23, 23),
   TMC(24, 24), TMC(25, 23), TMC(26, 24), TMC(27, 23), TMC(28, 24),
   TMC(29, 23), TMC(30, 20), TMC(31, 18), TMC(32, 19), TMC(33, 22),
   TMC(34, 19), TMC(35, 20), TMC(36, 18), TMC(37, 74), TMC(38, 49),
   TMC(39, 16), TMC(40, 75), TMC(41, 49), TMC(41, 19), TMC(42, 14),
   TMC(43, 76), TMC(44, 77), TMC(45, 70), TMC(46, 78), TMC(47, 75),
   TMC(48, 79), TMC(49, 67), TMC(50, 82), TMC(50, 85), TMC(51, 5),
   TMC(52, 50), TMC(53, 6), TMC(54, 6), TMC(55, 12), TMC(55, 87),
   TMC(55, 89), TMC(56, 7), TMC(57, 77), TMC(58, 90), TMC(59, 91),
   TMC(60, 92), TMC(60, 94), TMC(61, 1), TMC(62, 1), TMC(63, 96),
   TMC(64, 95), TMC(65, 96), TMC(66, 2), TMC(67, 61), TMC(68, 61),
   TMC(69, 61), TMC(70, 61), TMC(71, 96), TMC(72, 2), TMC(73, 96),
   TMC(74, 4), TMC(75, 2), TMC(76, 2), TMC(77, 98), TMC(79, 99)]
  end
  local
  val DT = Thm.disk_thm val read = Term.read_raw tmvector
  in
  val op complex_rational_TY_DEF =
    DT(["DISK_THM"],
       [read"(%73 (|%41. ((%109 (|%18. (%52 (|%0. ((%71 (%55 (|%18. ((%71 (%74 (|%16. (%74 (|%19. ((%70 $2) (((|%16. (|%19. (((%97 %60) ((%58 $1) $0)) (|%36. %78)))) $1) $0))))))) ($1 $0))))) ($0 $1)))))) $0)))"])
  val op complex_rational_case_def =
    DT(["DISK_THM"],
       [read"(%54 (|%16. (%54 (|%19. (%51 (|%29. ((%61 ((%117 ((%93 $2) $1)) $0)) (($0 $2) $1))))))))"])
  val op complex_rational_size_def =
    DT(["DISK_THM"],
       [read"(%54 (|%16. (%54 (|%19. ((%67 (%120 ((%93 $1) $0))) (%106 (%77 %113)))))))"])
  val op com_0_def = DT([], [read"((%63 %115) ((%93 %126) %126))"])
  val op com_1_def = DT([], [read"((%63 %116) ((%93 %127) %126))"])
  val op COMPLEX_ADD_tupled_primitive_def =
    DT([],
       [read"((%65 %80) ((%112 (%75 (|%12. (%110 $0)))) (|%1. (|%14. ((%125 $0) (|%42. (|%43. ((%119 $1) (|%19. (|%24. ((%119 $2) (|%21. (|%25. (%102 ((%93 ((%128 $3) $1)) ((%128 $2) $0))))))))))))))))"])
  val op COMPLEX_ADD_curried_def =
    DT([],
       [read"(%48 (|%44. (%48 (|%46. ((%63 ((%79 $1) $0)) (%80 ((%56 $1) $0)))))))"])
  val op COMPLEX_SUB_tupled_primitive_def =
    DT([],
       [read"((%65 %96) ((%112 (%75 (|%12. (%110 $0)))) (|%7. (|%14. ((%125 $0) (|%42. (|%43. ((%119 $1) (|%19. (|%24. ((%119 $2) (|%21. (|%25. (%102 ((%93 ((%138 $3) $1)) ((%138 $2) $0))))))))))))))))"])
  val op COMPLEX_SUB_curried_def =
    DT([],
       [read"(%48 (|%44. (%48 (|%46. ((%63 ((%95 $1) $0)) (%96 ((%56 $1) $0)))))))"])
  val op COMPLEX_MULT_tupled_primitive_def =
    DT([],
       [read"((%65 %91) ((%112 (%75 (|%12. (%110 $0)))) (|%6. (|%14. ((%125 $0) (|%42. (|%43. ((%119 $1) (|%19. (|%24. ((%119 $2) (|%21. (|%25. (%102 ((%93 ((%138 ((%136 $3) $1)) ((%136 $2) $0))) ((%128 ((%136 $2) $1)) ((%136 $3) $0)))))))))))))))))"])
  val op COMPLEX_MULT_curried_def =
    DT([],
       [read"(%48 (|%44. (%48 (|%46. ((%63 ((%90 $1) $0)) (%91 ((%56 $1) $0)))))))"])
  val op COMPLEX_RECIPROCAL_def =
    DT(["DISK_THM"],
       [read"(%54 (|%15. (%54 (|%23. ((%63 (%94 ((%93 $1) $0))) ((%93 ((%130 $1) ((%128 ((%136 $1) $1)) ((%136 $0) $0)))) ((%130 (%129 $0)) ((%128 ((%136 $1) $1)) ((%136 $0) $0)))))))))"])
  val op COMPLEX_LT_tupled_primitive_def =
    DT([],
       [read"((%64 %89) ((%111 (%75 (|%12. (%110 $0)))) (|%5. (|%14. ((%124 $0) (|%42. (|%43. ((%118 $1) (|%39. (|%32. ((%118 $2) (|%40. (|%33. (%101 ((%114 ((%135 $3) $1)) ((%59 ((%69 $3) $1)) ((%135 $2) $0)))))))))))))))))"])
  val op COMPLEX_LT_curried_def =
    DT([],
       [read"(%48 (|%44. (%48 (|%46. ((%62 ((%88 $1) $0)) (%89 ((%56 $1) $0)))))))"])
  val op COMPLEX_LE_tupled_primitive_def =
    DT([],
       [read"((%64 %87) ((%111 (%75 (|%12. (%110 $0)))) (|%4. (|%14. ((%124 $0) (|%42. (|%43. ((%118 $1) (|%39. (|%32. ((%118 $2) (|%40. (|%33. (%101 ((%114 ((%135 $3) $1)) ((%59 ((%69 $3) $1)) ((%134 $2) $0)))))))))))))))))"])
  val op COMPLEX_LE_curried_def =
    DT([],
       [read"(%48 (|%44. (%48 (|%46. ((%62 ((%86 $1) $0)) (%87 ((%56 $1) $0)))))))"])
  val op COMPLEX_GT_tupled_primitive_def =
    DT([],
       [read"((%64 %85) ((%111 (%75 (|%12. (%110 $0)))) (|%3. (|%14. ((%124 $0) (|%42. (|%43. ((%118 $1) (|%39. (|%32. ((%118 $2) (|%40. (|%33. (%101 ((%114 ((%133 $3) $1)) ((%59 ((%69 $3) $1)) ((%133 $2) $0)))))))))))))))))"])
  val op COMPLEX_GT_curried_def =
    DT([],
       [read"(%48 (|%44. (%48 (|%46. ((%62 ((%84 $1) $0)) (%85 ((%56 $1) $0)))))))"])
  val op COMPLEX_GE_tupled_primitive_def =
    DT([],
       [read"((%64 %83) ((%111 (%75 (|%12. (%110 $0)))) (|%2. (|%14. ((%124 $0) (|%42. (|%43. ((%118 $1) (|%39. (|%32. ((%118 $2) (|%40. (|%33. (%101 ((%114 ((%133 $3) $1)) ((%59 ((%69 $3) $1)) ((%132 $2) $0)))))))))))))))))"])
  val op COMPLEX_GE_curried_def =
    DT([],
       [read"(%48 (|%44. (%48 (|%46. ((%62 ((%82 $1) $0)) (%83 ((%56 $1) $0)))))))"])
  val op COMPLEX_NEG_def =
    DT([], [read"(%48 (|%13. ((%63 (%92 $0)) ((%95 %115) $0))))"])
  val op COMPLEX_DIV_def =
    DT([],
       [read"(%48 (|%13. (%48 (|%22. ((%63 ((%81 $1) $0)) ((%90 $1) (%94 $0)))))))"])
  val op DIVIDES_def =
    DT([],
       [read"(%53 (|%34. (%53 (|%35. ((%62 ((%99 $1) $0)) ((%67 ((%105 (%107 (%76 $0))) (%107 (%76 $1)))) %60))))))"])
  val op IS_INT_def =
    DT(["DISK_THM"],
       [read"(%54 (|%15. (%54 (|%23. ((%62 (%103 ((%93 $1) $0))) ((%59 ((%99 (%131 $1)) (%137 $1))) ((%69 $0) %126)))))))"])
  val op reduce_def =
    DT(["DISK_THM"],
       [read"(%53 (|%45. (%53 (|%47. ((%68 (%139 ((%57 $1) $0))) ((%104 (|%35. ((%57 ((%122 $2) $0)) ((%122 $1) $0)))) (%123 ((%121 (%107 (%76 $1))) (%107 (%76 $0))))))))))"])
  val op reduced_nmr_def =
    DT([],
       [read"(%54 (|%37. ((%66 (%141 $0)) (%100 (%139 (%142 (%143 $0)))))))"])
  val op reduced_dnm_def =
    DT([],
       [read"(%54 (|%37. ((%66 (%140 $0)) (%108 (%139 (%142 (%143 $0)))))))"])
  val op datatype_complex_rational =
    DT(["DISK_THM"], [read"(%98 (%28 %93))"])
  val op complex_rational_11 =
    DT(["DISK_THM"],
       [read"(%54 (|%16. (%54 (|%19. (%54 (|%17. (%54 (|%20. ((%62 ((%63 ((%93 $3) $2)) ((%93 $1) $0))) ((%59 ((%69 $3) $1)) ((%69 $2) $0)))))))))))"])
  val op complex_rational_case_cong =
    DT(["DISK_THM"],
       [read"(%48 (|%8. (%48 (|%9. (%51 (|%29. ((%71 ((%59 ((%63 $2) $1)) (%54 (|%16. (%54 (|%19. ((%71 ((%63 $3) ((%93 $1) $0))) ((%61 (($2 $1) $0)) ((%30 $1) $0))))))))) ((%61 ((%117 $2) $0)) ((%117 $1) %30)))))))))"])
  val op complex_rational_nchotomy =
    DT(["DISK_THM"],
       [read"(%48 (|%27. (%74 (|%37. (%74 (|%38. ((%63 $2) ((%93 $1) $0))))))))"])
  val op complex_rational_Axiom =
    DT(["DISK_THM"],
       [read"(%51 (|%29. (%72 (|%31. (%54 (|%16. (%54 (|%19. ((%61 ($2 ((%93 $1) $0))) (($3 $1) $0))))))))))"])
  val op complex_rational_induction =
    DT(["DISK_THM"],
       [read"(%49 (|%10. ((%71 (%54 (|%37. (%54 (|%38. ($2 ((%93 $1) $0))))))) (%48 (|%26. ($1 $0))))))"])
  val op COMPLEX_ADD_ind =
    DT(["DISK_THM"],
       [read"(%50 (|%11. ((%71 (%54 (|%19. (%54 (|%24. (%54 (|%21. (%54 (|%25. (($4 ((%93 $3) $2)) ((%93 $1) $0))))))))))) (%48 (|%42. (%48 (|%43. (($2 $1) $0))))))))"])
  val op COMPLEX_ADD_def =
    DT(["DISK_THM"],
       [read"((%63 ((%79 ((%93 %19) %24)) ((%93 %21) %25))) ((%93 ((%128 %19) %21)) ((%128 %24) %25)))"])
  val op COMPLEX_SUB_ind =
    DT(["DISK_THM"],
       [read"(%50 (|%11. ((%71 (%54 (|%19. (%54 (|%24. (%54 (|%21. (%54 (|%25. (($4 ((%93 $3) $2)) ((%93 $1) $0))))))))))) (%48 (|%42. (%48 (|%43. (($2 $1) $0))))))))"])
  val op COMPLEX_SUB_def =
    DT(["DISK_THM"],
       [read"((%63 ((%95 ((%93 %19) %24)) ((%93 %21) %25))) ((%93 ((%138 %19) %21)) ((%138 %24) %25)))"])
  val op COMPLEX_MULT_ind =
    DT(["DISK_THM"],
       [read"(%50 (|%11. ((%71 (%54 (|%19. (%54 (|%24. (%54 (|%21. (%54 (|%25. (($4 ((%93 $3) $2)) ((%93 $1) $0))))))))))) (%48 (|%42. (%48 (|%43. (($2 $1) $0))))))))"])
  val op COMPLEX_MULT_def =
    DT(["DISK_THM"],
       [read"((%63 ((%90 ((%93 %19) %24)) ((%93 %21) %25))) ((%93 ((%138 ((%136 %19) %21)) ((%136 %24) %25))) ((%128 ((%136 %24) %21)) ((%136 %19) %25))))"])
  val op COMPLEX_LT_ind =
    DT(["DISK_THM"],
       [read"(%50 (|%11. ((%71 (%54 (|%39. (%54 (|%32. (%54 (|%40. (%54 (|%33. (($4 ((%93 $3) $2)) ((%93 $1) $0))))))))))) (%48 (|%42. (%48 (|%43. (($2 $1) $0))))))))"])
  val op COMPLEX_LT_def =
    DT(["DISK_THM"],
       [read"((%62 ((%88 ((%93 %39) %32)) ((%93 %40) %33))) ((%114 ((%135 %39) %40)) ((%59 ((%69 %39) %40)) ((%135 %32) %33))))"])
  val op COMPLEX_LE_ind =
    DT(["DISK_THM"],
       [read"(%50 (|%11. ((%71 (%54 (|%39. (%54 (|%32. (%54 (|%40. (%54 (|%33. (($4 ((%93 $3) $2)) ((%93 $1) $0))))))))))) (%48 (|%42. (%48 (|%43. (($2 $1) $0))))))))"])
  val op COMPLEX_LE_def =
    DT(["DISK_THM"],
       [read"((%62 ((%86 ((%93 %39) %32)) ((%93 %40) %33))) ((%114 ((%135 %39) %40)) ((%59 ((%69 %39) %40)) ((%134 %32) %33))))"])
  val op COMPLEX_GT_ind =
    DT(["DISK_THM"],
       [read"(%50 (|%11. ((%71 (%54 (|%39. (%54 (|%32. (%54 (|%40. (%54 (|%33. (($4 ((%93 $3) $2)) ((%93 $1) $0))))))))))) (%48 (|%42. (%48 (|%43. (($2 $1) $0))))))))"])
  val op COMPLEX_GT_def =
    DT(["DISK_THM"],
       [read"((%62 ((%84 ((%93 %39) %32)) ((%93 %40) %33))) ((%114 ((%133 %39) %40)) ((%59 ((%69 %39) %40)) ((%133 %32) %33))))"])
  val op COMPLEX_GE_ind =
    DT(["DISK_THM"],
       [read"(%50 (|%11. ((%71 (%54 (|%39. (%54 (|%32. (%54 (|%40. (%54 (|%33. (($4 ((%93 $3) $2)) ((%93 $1) $0))))))))))) (%48 (|%42. (%48 (|%43. (($2 $1) $0))))))))"])
  val op COMPLEX_GE_def =
    DT(["DISK_THM"],
       [read"((%62 ((%82 ((%93 %39) %32)) ((%93 %40) %33))) ((%114 ((%133 %39) %40)) ((%59 ((%69 %39) %40)) ((%132 %32) %33))))"])
  val op COMPLEX_MULT_COMM =
    DT(["DISK_THM"], [read"((%63 ((%90 %13) %22)) ((%90 %22) %13))"])
  val op COMPLEX_MULT_ASSOC =
    DT(["DISK_THM"],
       [read"((%63 ((%90 %13) ((%90 %22) %26))) ((%90 ((%90 %13) %22)) %26))"])
  val op COMPLEX_MULT_RID =
    DT(["DISK_THM"], [read"((%63 ((%90 %13) %116)) %13)"])
  end
  val _ = DB.bindl "complex_rational"
  [("complex_rational_TY_DEF",complex_rational_TY_DEF,DB.Def),
   ("complex_rational_case_def",complex_rational_case_def,DB.Def),
   ("complex_rational_size_def",complex_rational_size_def,DB.Def),
   ("com_0_def",com_0_def,DB.Def), ("com_1_def",com_1_def,DB.Def),
   ("COMPLEX_ADD_tupled_primitive_def",
    COMPLEX_ADD_tupled_primitive_def,
    DB.Def), ("COMPLEX_ADD_curried_def",COMPLEX_ADD_curried_def,DB.Def),
   ("COMPLEX_SUB_tupled_primitive_def",
    COMPLEX_SUB_tupled_primitive_def,
    DB.Def), ("COMPLEX_SUB_curried_def",COMPLEX_SUB_curried_def,DB.Def),
   ("COMPLEX_MULT_tupled_primitive_def",
    COMPLEX_MULT_tupled_primitive_def,
    DB.Def), ("COMPLEX_MULT_curried_def",COMPLEX_MULT_curried_def,DB.Def),
   ("COMPLEX_RECIPROCAL_def",COMPLEX_RECIPROCAL_def,DB.Def),
   ("COMPLEX_LT_tupled_primitive_def",
    COMPLEX_LT_tupled_primitive_def,
    DB.Def), ("COMPLEX_LT_curried_def",COMPLEX_LT_curried_def,DB.Def),
   ("COMPLEX_LE_tupled_primitive_def",
    COMPLEX_LE_tupled_primitive_def,
    DB.Def), ("COMPLEX_LE_curried_def",COMPLEX_LE_curried_def,DB.Def),
   ("COMPLEX_GT_tupled_primitive_def",
    COMPLEX_GT_tupled_primitive_def,
    DB.Def), ("COMPLEX_GT_curried_def",COMPLEX_GT_curried_def,DB.Def),
   ("COMPLEX_GE_tupled_primitive_def",
    COMPLEX_GE_tupled_primitive_def,
    DB.Def), ("COMPLEX_GE_curried_def",COMPLEX_GE_curried_def,DB.Def),
   ("COMPLEX_NEG_def",COMPLEX_NEG_def,DB.Def),
   ("COMPLEX_DIV_def",COMPLEX_DIV_def,DB.Def),
   ("DIVIDES_def",DIVIDES_def,DB.Def), ("IS_INT_def",IS_INT_def,DB.Def),
   ("reduce_def",reduce_def,DB.Def),
   ("reduced_nmr_def",reduced_nmr_def,DB.Def),
   ("reduced_dnm_def",reduced_dnm_def,DB.Def),
   ("datatype_complex_rational",datatype_complex_rational,DB.Thm),
   ("complex_rational_11",complex_rational_11,DB.Thm),
   ("complex_rational_case_cong",complex_rational_case_cong,DB.Thm),
   ("complex_rational_nchotomy",complex_rational_nchotomy,DB.Thm),
   ("complex_rational_Axiom",complex_rational_Axiom,DB.Thm),
   ("complex_rational_induction",complex_rational_induction,DB.Thm),
   ("COMPLEX_ADD_ind",COMPLEX_ADD_ind,DB.Thm),
   ("COMPLEX_ADD_def",COMPLEX_ADD_def,DB.Thm),
   ("COMPLEX_SUB_ind",COMPLEX_SUB_ind,DB.Thm),
   ("COMPLEX_SUB_def",COMPLEX_SUB_def,DB.Thm),
   ("COMPLEX_MULT_ind",COMPLEX_MULT_ind,DB.Thm),
   ("COMPLEX_MULT_def",COMPLEX_MULT_def,DB.Thm),
   ("COMPLEX_LT_ind",COMPLEX_LT_ind,DB.Thm),
   ("COMPLEX_LT_def",COMPLEX_LT_def,DB.Thm),
   ("COMPLEX_LE_ind",COMPLEX_LE_ind,DB.Thm),
   ("COMPLEX_LE_def",COMPLEX_LE_def,DB.Thm),
   ("COMPLEX_GT_ind",COMPLEX_GT_ind,DB.Thm),
   ("COMPLEX_GT_def",COMPLEX_GT_def,DB.Thm),
   ("COMPLEX_GE_ind",COMPLEX_GE_ind,DB.Thm),
   ("COMPLEX_GE_def",COMPLEX_GE_def,DB.Thm),
   ("COMPLEX_MULT_COMM",COMPLEX_MULT_COMM,DB.Thm),
   ("COMPLEX_MULT_ASSOC",COMPLEX_MULT_ASSOC,DB.Thm),
   ("COMPLEX_MULT_RID",COMPLEX_MULT_RID,DB.Thm)]

  local open Portable GrammarSpecials Parse
    fun UTOFF f = Feedback.trace("Parse.unicode_trace_off_complaints",0)f
  in
  val _ = mk_local_grms [("ratTheory.rat_grammars",ratTheory.rat_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms temp_add_type "complex_rational"
  val _ = update_grms temp_add_type "complex_rational"




  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_RATIONAL", (Term.prim_mk_const { Name = "COMPLEX_RATIONAL", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_RATIONAL", (Term.prim_mk_const { Name = "COMPLEX_RATIONAL", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("complex_rational_CASE", (Term.prim_mk_const { Name = "complex_rational_CASE", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("complex_rational_size", (Term.prim_mk_const { Name = "complex_rational_size", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("com", (Term.prim_mk_const { Name = "COMPLEX_RATIONAL", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("com_0", (Term.prim_mk_const { Name = "com_0", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("com_0", (Term.prim_mk_const { Name = "com_0", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("com_1", (Term.prim_mk_const { Name = "com_1", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("com_1", (Term.prim_mk_const { Name = "com_1", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_ADD_tupled", (Term.prim_mk_const { Name = "COMPLEX_ADD_tupled", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_ADD_tupled", (Term.prim_mk_const { Name = "COMPLEX_ADD_tupled", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_ADD", (Term.prim_mk_const { Name = "COMPLEX_ADD", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_ADD", (Term.prim_mk_const { Name = "COMPLEX_ADD", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("+", (Term.prim_mk_const { Name = "COMPLEX_ADD", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_SUB_tupled", (Term.prim_mk_const { Name = "COMPLEX_SUB_tupled", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_SUB_tupled", (Term.prim_mk_const { Name = "COMPLEX_SUB_tupled", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_SUB", (Term.prim_mk_const { Name = "COMPLEX_SUB", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_SUB", (Term.prim_mk_const { Name = "COMPLEX_SUB", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("-", (Term.prim_mk_const { Name = "COMPLEX_SUB", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_MULT_tupled", (Term.prim_mk_const { Name = "COMPLEX_MULT_tupled", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_MULT_tupled", (Term.prim_mk_const { Name = "COMPLEX_MULT_tupled", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_MULT", (Term.prim_mk_const { Name = "COMPLEX_MULT", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_MULT", (Term.prim_mk_const { Name = "COMPLEX_MULT", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("*", (Term.prim_mk_const { Name = "COMPLEX_MULT", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_RECIPROCAL", (Term.prim_mk_const { Name = "COMPLEX_RECIPROCAL", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_LT_tupled", (Term.prim_mk_const { Name = "COMPLEX_LT_tupled", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_LT_tupled", (Term.prim_mk_const { Name = "COMPLEX_LT_tupled", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_LT", (Term.prim_mk_const { Name = "COMPLEX_LT", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_LT", (Term.prim_mk_const { Name = "COMPLEX_LT", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_LE_tupled", (Term.prim_mk_const { Name = "COMPLEX_LE_tupled", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_LE_tupled", (Term.prim_mk_const { Name = "COMPLEX_LE_tupled", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_LE", (Term.prim_mk_const { Name = "COMPLEX_LE", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_LE", (Term.prim_mk_const { Name = "COMPLEX_LE", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_GT_tupled", (Term.prim_mk_const { Name = "COMPLEX_GT_tupled", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_GT_tupled", (Term.prim_mk_const { Name = "COMPLEX_GT_tupled", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_GT", (Term.prim_mk_const { Name = "COMPLEX_GT", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_GT", (Term.prim_mk_const { Name = "COMPLEX_GT", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_GE_tupled", (Term.prim_mk_const { Name = "COMPLEX_GE_tupled", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_GE_tupled", (Term.prim_mk_const { Name = "COMPLEX_GE_tupled", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_GE", (Term.prim_mk_const { Name = "COMPLEX_GE", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_GE", (Term.prim_mk_const { Name = "COMPLEX_GE", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("<", (Term.prim_mk_const { Name = "COMPLEX_LT", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("<=", (Term.prim_mk_const { Name = "COMPLEX_LE", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       (">", (Term.prim_mk_const { Name = "COMPLEX_GT", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       (">=", (Term.prim_mk_const { Name = "COMPLEX_GE", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_NEG", (Term.prim_mk_const { Name = "COMPLEX_NEG", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_NEG", (Term.prim_mk_const { Name = "COMPLEX_NEG", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("~", (Term.prim_mk_const { Name = "COMPLEX_NEG", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_DIV", (Term.prim_mk_const { Name = "COMPLEX_DIV", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("COMPLEX_DIV", (Term.prim_mk_const { Name = "COMPLEX_DIV", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("/", (Term.prim_mk_const { Name = "COMPLEX_DIV", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("DIVIDES", (Term.prim_mk_const { Name = "DIVIDES", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("DIVIDES", (Term.prim_mk_const { Name = "DIVIDES", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("IS_INT", (Term.prim_mk_const { Name = "IS_INT", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("reduce", (Term.prim_mk_const { Name = "reduce", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("reduce", (Term.prim_mk_const { Name = "reduce", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("reduced_nmr", (Term.prim_mk_const { Name = "reduced_nmr", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("reduced_nmr", (Term.prim_mk_const { Name = "reduced_nmr", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("reduced_dnm", (Term.prim_mk_const { Name = "reduced_dnm", Thy = "complex_rational"}))
  val _ = update_grms
       (UTOFF temp_overload_on)
       ("reduced_dnm", (Term.prim_mk_const { Name = "reduced_dnm", Thy = "complex_rational"}))
  val complex_rational_grammars = Parse.current_lgrms()
  end


  val _ =
    TypeBase.write [
      let
        open TypeBasePure
        val tyinfo0 = mk_datatype_info
          {ax=ORIG complex_rational_Axiom,
           case_def=complex_rational_case_def,
           case_cong=complex_rational_case_cong,
           induction=ORIG complex_rational_induction,
           nchotomy=complex_rational_nchotomy,
           size=SOME(Parse.Term`(complex_rational$complex_rational_size) :(complex_rational$complex_rational) -> (num$num)`,
                     ORIG complex_rational_size_def),
           encode = NONE,
           lift=NONE,
           one_one=SOME complex_rational_11,
           distinct=NONE,
           fields=let fun T t s A = mk_thy_type{Thy=t,Tyop=s,Args=A}
    val U = mk_vartype
in
[] end,
           accessors=[],
           updates=[],
           recognizers=[],
           destructors=[]}
        val tyinfo0 = tyinfo0
        val () = computeLib.write_datatype_info tyinfo0
      in
        tyinfo0
      end
    ];
  val _ = Theory.LoadableThyData.temp_encoded_update {
    thy = "complex_rational",
    thydataty = "compute",
    data =
        "complex_rational.com_0_def complex_rational.reduced_dnm_def complex_rational.reduced_nmr_def complex_rational.com_1_def complex_rational.reduce_def complex_rational.IS_INT_def complex_rational.DIVIDES_def complex_rational.COMPLEX_DIV_def complex_rational.COMPLEX_NEG_def complex_rational.COMPLEX_GE_def complex_rational.COMPLEX_GT_def complex_rational.COMPLEX_LE_def complex_rational.COMPLEX_LT_def complex_rational.COMPLEX_RECIPROCAL_def complex_rational.COMPLEX_MULT_def complex_rational.COMPLEX_SUB_def complex_rational.COMPLEX_ADD_def"
  }

val _ = if !Globals.print_thy_loads then print "done\n" else ()
val _ = Theory.load_complete "complex_rational"
end
