signature fmap_encodeTheory =
sig
  type thm = Thm.thm

  (*  Definitions  *)
    val L2M_def : thm
    val M2L_def : thm
    val MAPSET_def : thm
    val SETEQ_def : thm
    val SEXP_LE_def : thm
    val SEXP_LT_def : thm
    val SORTEDSET_def : thm
    val SORTSET_def : thm
    val ains_curried_def : thm
    val ains_tupled_primitive_def : thm
    val all_fmap_def : thm
    val decode_fmap_def : thm
    val detect_fmap_def : thm
    val encode_fmap_def : thm
    val fix_fmap_def : thm
    val fold_curried_def : thm
    val fold_tupled_primitive_def : thm
    val insert_curried_def : thm
    val insert_tupled_primitive_def : thm
    val map_fmap_def : thm
    val sorted_car_primitive_def : thm
    val uniql_def : thm
    val uniqs_def : thm

  (*  Theorems  *)
    val ALLID_FMAP : thm
    val ALL_DISTINCT_CONS : thm
    val ALL_DISTINCT_M2L : thm
    val ALL_DISTINCT_MAP : thm
    val ALL_DISTINCT_MAPFST : thm
    val ALL_DISTINCT_MAPFST_INSERT : thm
    val ALL_DISTINCT_MAPFST_M2L : thm
    val ANTISYM_INV : thm
    val APPLY_L2M_M2L : thm
    val DECENCFIX_FMAP : thm
    val DETECTDEAD_FMAP : thm
    val DETECT_GENERAL_FMAP : thm
    val EL_MAP_FITLE : thm
    val ENCDECMAP_FMAP : thm
    val ENCDETALL_FMAP : thm
    val ENCMAPENC_FMAP : thm
    val EVERY_PERM : thm
    val EXISTS_MEM_M2L : thm
    val FDOM_L2M : thm
    val FILTER_EQ_SEXP_SORT : thm
    val FILTER_SET : thm
    val FIXID_FMAP : thm
    val FMAP_MAP_COMPOSE : thm
    val INSERT_EQ : thm
    val INSERT_FUPDATE : thm
    val INSERT_INSERTS : thm
    val INSERT_MEM : thm
    val INSERT_SET : thm
    val INVIMAGE_I : thm
    val INVIMAGE_K : thm
    val INV_INV_IMAGE : thm
    val INV_LEX_PAIRMAP : thm
    val IRREFL_INV : thm
    val L2M : thm
    val L2M_APPLY : thm
    val L2M_APPLY_MAP_EQ : thm
    val L2M_EQ : thm
    val L2M_M2L : thm
    val L2M_M2L_SETLIST : thm
    val LIST_LEX_ORDER_NIL : thm
    val M2L_L2M : thm
    val M2L_L2M_MAP : thm
    val M2L_L2M_MAP_SETEQ : thm
    val M2L_L2M_SETEQ : thm
    val MAPID_FMAP : thm
    val MAPSET_CONS : thm
    val MAPSET_DISTINCT : thm
    val MAPSET_UNIQ : thm
    val MAPSET_sortedcar : thm
    val MAP_EQ_LENGTH : thm
    val MAP_FST_DISTINCT_EQ : thm
    val MAP_FST_SND_EQ : thm
    val MEM_EL_FILTER : thm
    val MEM_INSERT : thm
    val MEM_M2L : thm
    val MEM_MAPFST_INSERT : thm
    val MEM_PERM : thm
    val ONE_ONE_I : thm
    val ONE_ONE_RING : thm
    val ONE_ONE_RING2 : thm
    val PAIR_MAP_COMPOSE : thm
    val PERM_CONS_IFF2 : thm
    val PERM_S2L_L2S : thm
    val PERM_SETEQ : thm
    val PERM_SORTED_EQ : thm
    val PERM_UNIQL : thm
    val QSORT3_M2L_L2M_MAP : thm
    val QSORT3_M2L_L2M_MAP_INV : thm
    val QSORT3_PAIRMAP : thm
    val QSORT3_PAIRMAP_INV : thm
    val SETEQ_COMM : thm
    val SETEQ_MAP : thm
    val SETEQ_PERM : thm
    val SETEQ_SYM : thm
    val SETEQ_THM : thm
    val SETEQ_TRANS : thm
    val SET_M2L_DOMSUB : thm
    val SET_M2L_FUPDATE : thm
    val SEXP_LE_ANTISYMMETRIC : thm
    val SEXP_LE_TOTAL : thm
    val SEXP_LE_TRANSITIVE : thm
    val SEXP_LT_IRREFLEXIVE : thm
    val SEXP_LT_TRANSITIVE : thm
    val SORTED_CONS : thm
    val SORTED_INSERT : thm
    val SORTED_LEX : thm
    val SORTED_MAP : thm
    val SORTSET_SORTEDSET : thm
    val STABLE_FST_EQ : thm
    val STRING_LESS_EQ_REFL : thm
    val TOTAL_INV : thm
    val TOTAL_K : thm
    val TOTAL_LEX : thm
    val TRANSITIVE_K : thm
    val TRANSITIVE_LEX : thm
    val TRANS_INV : thm
    val UNIQL_M2L : thm
    val UNIQL_MAP : thm
    val ains_def : thm
    val ains_ind : thm
    val ains_insert : thm
    val apply_rewrite : thm
    val assoc_list : thm
    val booleanp_sortedcar : thm
    val consp_list_to_sexp : thm
    val fdom_rewrite : thm
    val fempty_rewrite : thm
    val fold_FEMPTY : thm
    val fold_def : thm
    val fold_ind : thm
    val fupdate_rewrite : thm
    val insert_def : thm
    val insert_ind : thm
    val ite_rewrites : thm
    val not_nil : thm
    val sorted_car_def : thm
    val sorted_car_distinct : thm
    val sorted_car_ind : thm
    val sorted_car_rewrite : thm
    val sorted_car_sorted : thm

  val fmap_encode_grammars : type_grammar.grammar * term_grammar.grammar
(*
   [finite_map] Parent theory of "fmap_encode"

   [translate] Parent theory of "fmap_encode"

   [L2M_def]  Definition

      |- L2M = FOLDR (combin$C $|+) FEMPTY

   [M2L_def]  Definition

      |- M2L = fold CONS []

   [MAPSET_def]  Definition

      |- ∀r l. MAPSET r l ⇔ SORTED r l ∧ ALL_DISTINCT (MAP FST l)

   [SETEQ_def]  Definition

      |- ∀l1 l2. SETEQ l1 l2 ⇔ ∀x. MEM x l1 ⇔ MEM x l2

   [SEXP_LE_def]  Definition

      |- ∀a b. a ≤ b ⇔ |= lexorder a b

   [SEXP_LT_def]  Definition

      |- ∀a b. a < b ⇔ a ≠ b ∧ a ≤ b

   [SORTEDSET_def]  Definition

      |- ∀r l. SORTEDSET r l ⇔ SORTED r l ∧ ALL_DISTINCT l

   [SORTSET_def]  Definition

      |- ∀sort relation.
           SORTSET sort relation = sort relation o SET_TO_LIST o set

   [ains_curried_def]  Definition

      |- ∀x x1. ains x x1 = ains_tupled (x,x1)

   [ains_tupled_primitive_def]  Definition

      |- ains_tupled =
         WFREC
           (@R.
              WF R ∧
              ∀a l.
                (not (consp l) = nil) ∧ (equal (caar l) (car a) = nil) ∧
                (lexorder (car a) (caar l) = nil) ⇒
                R (a,cdr l) (a,l))
           (λains_tupled a'.
              case a' of
                (a,l) =>
                  I
                    (itel
                       [(not (consp l),cons a nil);
                        (equal (caar l) (car a),cons a (cdr l));
                        (lexorder (car a) (caar l),cons a l)]
                       (cons (car l) (ains_tupled (a,cdr l)))))

   [all_fmap_def]  Definition

      |- ∀p1 p2. all_fmap p1 p2 = EVERY (all_pair p1 p2) o M2L

   [decode_fmap_def]  Definition

      |- ∀fdec tdec.
           decode_fmap fdec tdec =
           L2M o sexp_to_list (sexp_to_pair fdec tdec)

   [detect_fmap_def]  Definition

      |- ∀fdet tdet x.
           detect_fmap fdet tdet x ⇔
           (MAPSET ($<= LEX K (K T)) o sexp_to_list (sexp_to_pair I I)) x ∧
           listp (pairp fdet tdet) x

   [encode_fmap_def]  Definition

      |- ∀fenc tenc.
           encode_fmap fenc tenc =
           list (pair fenc tenc) o
           QSORT3 (inv_image $<= fenc LEX K (K T)) o M2L

   [fix_fmap_def]  Definition

      |- ∀f1 f2.
           fix_fmap f1 f2 =
           list (pair I I) o QSORT3 ($<= LEX K (K T)) o M2L o L2M o
           sexp_to_list (sexp_to_pair I I) o fix_list (fix_pair f1 f2)

   [fold_curried_def]  Definition

      |- ∀x x1 x2. fold x x1 x2 = fold_tupled (x,x1,x2)

   [fold_tupled_primitive_def]  Definition

      |- fold_tupled =
         WFREC
           (@R.
              WF R ∧
              ∀v f map x.
                map ≠ FEMPTY ∧ (x = @x. x ∈ FDOM map) ⇒
                R (f,v,map \\ x) (f,v,map))
           (λfold_tupled a.
              case a of
                (f,v,map) =>
                  I
                    (if map = FEMPTY then v
                     else
                       (let x = @x. x ∈ FDOM map
                        in
                          f (x,map ' x) (fold_tupled (f,v,map \\ x)))))

   [insert_curried_def]  Definition

      |- ∀x x1 x2. insert x x1 x2 = insert_tupled (x,x1,x2)

   [insert_tupled_primitive_def]  Definition

      |- insert_tupled =
         WFREC
           (@R'.
              WF R' ∧
              ∀hy tl y R x hx.
                hx ≠ x ∧ ¬R x hx ⇒ R' (R,(x,y),tl) (R,(x,y),(hx,hy)::tl))
           (λinsert_tupled a.
              case a of
                (R,(x,y),[]) => I [(x,y)]
              | (R,(x,y),(hx,hy)::tl) =>
                  I
                    (if hx = x then (x,y)::tl
                     else if R x hx then (x,y)::(hx,hy)::tl
                     else (hx,hy)::insert_tupled (R,(x,y),tl)))

   [map_fmap_def]  Definition

      |- ∀m1 m2. map_fmap m1 m2 = L2M o MAP (m1 ## m2) o M2L

   [sorted_car_primitive_def]  Definition

      |- sorted_car =
         WFREC
           (@R.
              WF R ∧ ∀a. andl [consp a; consp (cdr a)] ≠ nil ⇒ R (cdr a) a)
           (λsorted_car a.
              I
                (ite (andl [consp a; consp (cdr a)])
                   (andl
                      [not (equal (caar a) (caadr a));
                       lexorder (caar a) (caadr a); sorted_car (cdr a)])
                   t))

   [uniql_def]  Definition

      |- ∀l. uniql l ⇔ ∀x y y'. MEM (x,y) l ∧ MEM (x,y') l ⇒ (y = y')

   [uniqs_def]  Definition

      |- ∀s. uniqs s ⇔ ∀x y y'. (x,y) ∈ s ∧ (x,y') ∈ s ⇒ (y = y')

   [ALLID_FMAP]  Theorem

      |- all_fmap (K T) (K T) = K T

   [ALL_DISTINCT_CONS]  Theorem

      |- ∀l. ALL_DISTINCT (h::l) ⇒ ALL_DISTINCT l

   [ALL_DISTINCT_M2L]  Theorem

      |- ∀s. ALL_DISTINCT (M2L s)

   [ALL_DISTINCT_MAP]  Theorem

      |- ∀l f. ONE_ONE f ∧ ALL_DISTINCT l ⇒ ALL_DISTINCT (MAP f l)

   [ALL_DISTINCT_MAPFST]  Theorem

      |- ∀l. ALL_DISTINCT (MAP FST l) ⇒ ALL_DISTINCT l

   [ALL_DISTINCT_MAPFST_INSERT]  Theorem

      |- ∀l R x y.
           total R ∧ antisymmetric R ∧ transitive R ∧
           SORTED R (MAP FST l) ∧ ALL_DISTINCT (MAP FST l) ⇒
           ALL_DISTINCT (MAP FST (insert R (x,y) l))

   [ALL_DISTINCT_MAPFST_M2L]  Theorem

      |- ∀s. ALL_DISTINCT (MAP FST (M2L s))

   [ANTISYM_INV]  Theorem

      |- ∀R f. ONE_ONE f ∧ antisymmetric R ⇒ antisymmetric (inv_image R f)

   [APPLY_L2M_M2L]  Theorem

      |- ∀x y. y ∈ FDOM x ⇒ (L2M (M2L x) ' y = x ' y)

   [DECENCFIX_FMAP]  Theorem

      |- ∀fdec tdec fenc tenc.
           ONE_ONE (fdec o fenc) ⇒
           (encode_fmap fenc tenc o decode_fmap fdec tdec =
            fix_fmap (fenc o fdec) (tenc o tdec))

   [DETECTDEAD_FMAP]  Theorem

      |- ∀p0 p1. detect_fmap p0 p1 nil

   [DETECT_GENERAL_FMAP]  Theorem

      |- ∀p0 p1 x. detect_fmap p0 p1 x ⇒ detect_fmap (K T) (K T) x

   [EL_MAP_FITLE]  Theorem

      |- ∀f x.
           (MAP f l1 = MAP f l2) ∧ x < LENGTH l1 ∧
           (FILTER ($= (f (EL x l1)) o f) l1 =
            FILTER ($= (f (EL x l2)) o f) l2) ⇒
           (EL x l1 = EL x l2)

   [ENCDECMAP_FMAP]  Theorem

      |- ∀fdec tdec fenc tenc.
           ONE_ONE (fdec o fenc) ⇒
           (decode_fmap fdec tdec o encode_fmap fenc tenc =
            map_fmap (fdec o fenc) (tdec o tenc))

   [ENCDETALL_FMAP]  Theorem

      |- ∀p0 p1 f0 f1.
           ONE_ONE f0 ⇒
           (detect_fmap p0 p1 o encode_fmap f0 f1 =
            all_fmap (p0 o f0) (p1 o f1))

   [ENCMAPENC_FMAP]  Theorem

      |- ONE_ONE f0 ∧ ONE_ONE g0 ⇒
         (encode_fmap f0 f1 o map_fmap g0 g1 =
          encode_fmap (f0 o g0) (f1 o g1))

   [EVERY_PERM]  Theorem

      |- ∀l1 l2. PERM l1 l2 ⇒ (EVERY P l1 ⇔ EVERY P l2)

   [EXISTS_MEM_M2L]  Theorem

      |- ∀x a. (∃y. MEM (a,y) (M2L x)) ⇔ a ∈ FDOM x

   [FDOM_L2M]  Theorem

      |- ∀x y. y ∈ FDOM (L2M x) ⇔ ∃z. MEM (y,z) x

   [FILTER_EQ_SEXP_SORT]  Theorem

      |- ∀x l f.
           FILTER ($= x o FST) (QSORT3 (inv_image $<= f LEX K (K T)) l) =
           FILTER ($= x o FST) l

   [FILTER_SET]  Theorem

      |- ∀x.
           FINITE x ⇒
           ∀y. FILTER ($= y) (SET_TO_LIST x) = if y ∈ x then [y] else []

   [FIXID_FMAP]  Theorem

      |- (∀x. p0 x ⇒ (f0 x = x)) ∧ (∀x. p1 x ⇒ (f1 x = x)) ⇒
         ∀x. detect_fmap p0 p1 x ⇒ (fix_fmap f0 f1 x = x)

   [FMAP_MAP_COMPOSE]  Theorem

      |- ONE_ONE f0 ∧ ONE_ONE g0 ⇒
         (map_fmap f0 f1 o map_fmap g0 g1 = map_fmap (f0 o g0) (f1 o g1))

   [INSERT_EQ]  Theorem

      |- ∀l x y y'.
           antisymmetric R ∧ transitive (R LEX R') ∧
           ALL_DISTINCT (MAP FST l) ∧ SORTED (R LEX R') l ∧
           MEM (x,y) (insert R (x,y') l) ⇒
           (y = y')

   [INSERT_FUPDATE]  Theorem

      |- ∀x y R m.
           transitive R ∧ antisymmetric R ∧ total R ⇒
           (QSORT3 (R LEX K (K T)) (M2L (m |+ (x,y))) =
            insert R (x,y) (QSORT3 (R LEX K (K T)) (M2L m)))

   [INSERT_INSERTS]  Theorem

      |- ∀l x y R. MEM (x,y) (insert R (x,y) l)

   [INSERT_MEM]  Theorem

      |- ∀l x y q r R. MEM (x,y) l ⇒ MEM (x,y) (insert R (q,r) l) ∨ (x = q)

   [INSERT_SET]  Theorem

      |- ∀l R R' x y.
           transitive R ∧ antisymmetric R ∧ total R ∧
           transitive (R LEX R') ∧ SORTED (R LEX R') l ∧
           ALL_DISTINCT (MAP FST l) ⇒
           (set (insert R (x,y) l) =
            (x,y) INSERT set l DIFF {z | FST z = x})

   [INVIMAGE_I]  Theorem

      |- inv_image R I = R

   [INVIMAGE_K]  Theorem

      |- inv_image (K (K T)) x = K (K T)

   [INV_INV_IMAGE]  Theorem

      |- ∀h f. inv_image (inv_image R h) f = inv_image R (h o f)

   [INV_LEX_PAIRMAP]  Theorem

      |- ONE_ONE f ⇒
         (inv_image (R LEX R') (f ## g) = inv_image R f LEX inv_image R' g)

   [IRREFL_INV]  Theorem

      |- ∀R f. irreflexive R ⇒ irreflexive (inv_image R f)

   [L2M]  Theorem

      |- (L2M [] = FEMPTY) ∧ ∀a b. L2M (a::b) = L2M b |+ a

   [L2M_APPLY]  Theorem

      |- ∀x y z. uniql x ∧ MEM (y,z) x ⇒ (L2M x ' y = z)

   [L2M_APPLY_MAP_EQ]  Theorem

      |- ∀x f g y.
           ONE_ONE f ∧ (∃z. MEM (y,z) x) ⇒
           (L2M (MAP (f ## g) x) ' (f y) = g (L2M x ' y))

   [L2M_EQ]  Theorem

      |- ∀l1 l2.
           uniql l1 ∧ uniql l2 ∧ (set l1 = set l2) ⇒ (L2M l1 = L2M l2)

   [L2M_M2L]  Theorem

      |- ∀x. L2M (M2L x) = x

   [L2M_M2L_SETLIST]  Theorem

      |- ∀x. L2M (M2L x) = L2M (SET_TO_LIST (set (M2L x)))

   [LIST_LEX_ORDER_NIL]  Theorem

      |- (LIST_LEX_ORDER R [] x ⇔ x ≠ []) ∧ (LIST_LEX_ORDER R x [] ⇔ F)

   [M2L_L2M]  Theorem

      |- ∀sort R R'.
           total R ∧ antisymmetric R ∧ transitive R ∧ transitive R' ∧
           SORTS sort (R LEX R') ⇒
           ∀l. MAPSET (R LEX R') l ⇒ (sort (R LEX R') (M2L (L2M l)) = l)

   [M2L_L2M_MAP]  Theorem

      |- ∀l f g.
           ONE_ONE f ⇒
           PERM (M2L (L2M (MAP (f ## g) l))) (MAP (f ## g) (M2L (L2M l)))

   [M2L_L2M_MAP_SETEQ]  Theorem

      |- ∀l f g.
           ONE_ONE f ⇒
           SETEQ (M2L (L2M (MAP (f ## g) l))) (MAP (f ## g) (M2L (L2M l)))

   [M2L_L2M_SETEQ]  Theorem

      |- ∀x. uniql x ⇒ SETEQ x (M2L (L2M x))

   [MAPID_FMAP]  Theorem

      |- map_fmap I I = I

   [MAPSET_CONS]  Theorem

      |- ∀b a R.
           MAPSET ($<= LEX K (K T)) (a::b) ⇒ MAPSET ($<= LEX K (K T)) b

   [MAPSET_DISTINCT]  Theorem

      |- MAPSET R x ⇒ ALL_DISTINCT x

   [MAPSET_UNIQ]  Theorem

      |- ∀a R. MAPSET R a ⇒ uniql a

   [MAPSET_sortedcar]  Theorem

      |- ∀l.
           MAPSET ($<= LEX K (K T)) (sexp_to_list (sexp_to_pair I I) l) ⇒
           (sorted_car l = t)

   [MAP_EQ_LENGTH]  Theorem

      |- ∀l1 l2. (MAP f l1 = MAP g l2) ⇒ (LENGTH l1 = LENGTH l2)

   [MAP_FST_DISTINCT_EQ]  Theorem

      |- ∀l1 l2.
           (MAP FST l1 = MAP FST l2) ∧ ALL_DISTINCT (MAP FST l1) ∧
           PERM l1 l2 ⇒
           (l1 = l2)

   [MAP_FST_SND_EQ]  Theorem

      |- ∀l1 l2.
           (MAP FST l1 = MAP FST l2) ∧ (MAP SND l1 = MAP SND l2) ⇒
           (l1 = l2)

   [MEM_EL_FILTER]  Theorem

      |- ∀f l x.
           MEM x l ⇒
           ∃y.
             y < LENGTH (FILTER ($= (f x) o f) l) ∧
             (EL y (FILTER ($= (f x) o f) l) = x)

   [MEM_INSERT]  Theorem

      |- ∀l a x y.
           MEM a (insert R (x,y) l) ⇒ (FST a = x) ∧ (SND a = y) ∨ MEM a l

   [MEM_M2L]  Theorem

      |- ∀x y z. MEM (y,z) (M2L x) ⇔ y ∈ FDOM x ∧ (z = x ' y)

   [MEM_MAPFST_INSERT]  Theorem

      |- ∀l q x y.
           MEM q (MAP FST (insert R (x,y) l)) ⇔ (q = x) ∨ MEM q (MAP FST l)

   [MEM_PERM]  Theorem

      |- ∀l1 l2. PERM l1 l2 ⇒ ∀a. MEM a l1 ⇔ MEM a l2

   [ONE_ONE_I]  Theorem

      |- ONE_ONE I

   [ONE_ONE_RING]  Theorem

      |- ∀f g. ONE_ONE (f o g) ⇒ ONE_ONE g

   [ONE_ONE_RING2]  Theorem

      |- ONE_ONE a ∧ ONE_ONE b ⇒ ONE_ONE (a o b)

   [PAIR_MAP_COMPOSE]  Theorem

      |- ∀a b c d. a o b ## c o d = (a ## c) o (b ## d)

   [PERM_CONS_IFF2]  Theorem

      |- PERM (h1::t1) (h2::t1) ⇔ (h1 = h2)

   [PERM_S2L_L2S]  Theorem

      |- ∀l. ALL_DISTINCT l ⇒ PERM (SET_TO_LIST (set l)) l

   [PERM_SETEQ]  Theorem

      |- ∀l1 l2. PERM l1 l2 ⇒ SETEQ l1 l2

   [PERM_SORTED_EQ]  Theorem

      |- ∀l1 l2 r.
           (irreflexive r ∨ antisymmetric r) ∧ transitive r ∧ PERM l1 l2 ∧
           SORTED r l1 ∧ SORTED r l2 ⇒
           (l1 = l2)

   [PERM_UNIQL]  Theorem

      |- ∀l1 l2. PERM l1 l2 ⇒ (uniql l1 ⇔ uniql l2)

   [QSORT3_M2L_L2M_MAP]  Theorem

      |- ONE_ONE f ⇒
         (QSORT3 ($<= LEX K (K T)) (M2L (L2M (MAP (f ## g) l))) =
          QSORT3 ($<= LEX K (K T)) (MAP (f ## g) (M2L (L2M l))))

   [QSORT3_M2L_L2M_MAP_INV]  Theorem

      |- ∀l f g h.
           ONE_ONE f ∧ ONE_ONE h ⇒
           (QSORT3 (inv_image $<= h LEX K (K T))
              (M2L (L2M (MAP (f ## g) l))) =
            QSORT3 (inv_image $<= h LEX K (K T))
              (MAP (f ## g) (M2L (L2M l))))

   [QSORT3_PAIRMAP]  Theorem

      |- ∀f.
           ONE_ONE f ⇒
           ∀l g.
             QSORT3 ($<= LEX K (K T)) (MAP (f ## g) l) =
             MAP (f ## g) (QSORT3 (inv_image $<= (I o f) LEX K (K T)) l)

   [QSORT3_PAIRMAP_INV]  Theorem

      |- ∀f h.
           ONE_ONE f ∧ ONE_ONE h ⇒
           ∀l g.
             QSORT3 (inv_image $<= h LEX K (K T)) (MAP (f ## g) l) =
             MAP (f ## g) (QSORT3 (inv_image $<= (h o f) LEX K (K T)) l)

   [SETEQ_COMM]  Theorem

      |- SETEQ a b ⇔ SETEQ b a

   [SETEQ_MAP]  Theorem

      |- SETEQ a b ⇒ SETEQ (MAP f a) (MAP f b)

   [SETEQ_PERM]  Theorem

      |- ∀l1 l2.
           SETEQ l1 l2 ∧ ALL_DISTINCT l1 ∧ ALL_DISTINCT l2 ⇒ PERM l1 l2

   [SETEQ_SYM]  Theorem

      |- ∀l. SETEQ l l

   [SETEQ_THM]  Theorem

      |- ∀l1 l2. SETEQ l1 l2 ⇔ (set l1 = set l2)

   [SETEQ_TRANS]  Theorem

      |- ∀l1 l2 l3. SETEQ l1 l2 ∧ SETEQ l2 l3 ⇒ SETEQ l1 l3

   [SET_M2L_DOMSUB]  Theorem

      |- ∀m x. set (M2L (m \\ x)) = set (M2L m) DIFF {z | FST z = x}

   [SET_M2L_FUPDATE]  Theorem

      |- ∀x y. set (M2L (x |+ y)) = set (y::M2L (x \\ FST y))

   [SEXP_LE_ANTISYMMETRIC]  Theorem

      |- antisymmetric $<=

   [SEXP_LE_TOTAL]  Theorem

      |- total $<=

   [SEXP_LE_TRANSITIVE]  Theorem

      |- transitive $<=

   [SEXP_LT_IRREFLEXIVE]  Theorem

      |- irreflexive $<

   [SEXP_LT_TRANSITIVE]  Theorem

      |- transitive $<

   [SORTED_CONS]  Theorem

      |- ∀a b R. SORTED R (a::b) ⇒ SORTED R b

   [SORTED_INSERT]  Theorem

      |- ∀R.
           total R ⇒
           ∀l x y.
             SORTED (R LEX K (K T)) l ⇒
             SORTED (R LEX K (K T)) (insert R (x,y) l)

   [SORTED_LEX]  Theorem

      |- ∀R1 R2.
           total R1 ∧ transitive R1 ∧ transitive R2 ⇒
           ∀x. SORTED (R1 LEX R2) x ⇒ SORTED R1 (MAP FST x)

   [SORTED_MAP]  Theorem

      |- ∀l f R.
           transitive R ∧ SORTED (inv_image R f) l ⇒ SORTED R (MAP f l)

   [SORTSET_SORTEDSET]  Theorem

      |- ∀l.
           transitive R ∧ (irreflexive R ∨ antisymmetric R) ∧
           SORTS sort R ∧ SORTEDSET R l ⇒
           (SORTSET sort R l = l)

   [STABLE_FST_EQ]  Theorem

      |- ∀l1 l2.
           (MAP FST l1 = MAP FST l2) ∧
           (∀x. FILTER ($= x o FST) l1 = FILTER ($= x o FST) l2) ⇒
           (l1 = l2)

   [STRING_LESS_EQ_REFL]  Theorem

      |- STRING_LESS_EQ x x

   [TOTAL_INV]  Theorem

      |- ∀R f. total R ⇒ total (inv_image R f)

   [TOTAL_K]  Theorem

      |- total (K (K T))

   [TOTAL_LEX]  Theorem

      |- ∀R R'. total R ∧ total R' ⇒ total (R LEX R')

   [TRANSITIVE_K]  Theorem

      |- transitive (K (K T))

   [TRANSITIVE_LEX]  Theorem

      |- ∀R R'. transitive R ∧ transitive R' ⇒ transitive (R LEX R')

   [TRANS_INV]  Theorem

      |- ∀R f. transitive R ⇒ transitive (inv_image R f)

   [UNIQL_M2L]  Theorem

      |- ∀x. uniql (M2L x)

   [UNIQL_MAP]  Theorem

      |- ∀f g l. ONE_ONE f ∧ uniql l ⇒ uniql (MAP (f ## g) l)

   [ains_def]  Theorem

      |- ∀l a.
           ains a l =
           itel
             [(not (consp l),cons a nil);
              (equal (caar l) (car a),cons a (cdr l));
              (lexorder (car a) (caar l),cons a l)]
             (cons (car l) (ains a (cdr l)))

   [ains_ind]  Theorem

      |- ∀P.
           (∀a l.
              ((not (consp l) = nil) ∧ (equal (caar l) (car a) = nil) ∧
               (lexorder (car a) (caar l) = nil) ⇒
               P a (cdr l)) ⇒
              P a l) ⇒
           ∀v v1. P v v1

   [ains_insert]  Theorem

      |- ∀l f g x y.
           ONE_ONE f ⇒
           (ains (pair f g (x,y)) (list (pair f g) l) =
            list (pair f g) (insert (inv_image $<= f) (x,y) l))

   [apply_rewrite]  Theorem

      |- ∀y x.
           ONE_ONE f ∧ x ∈ FDOM y ⇒
           (g (y ' x) = cdr (assoc (f x) (encode_fmap f g y)))

   [assoc_list]  Theorem

      |- ∀y f g x.
           ONE_ONE f ⇒
           (assoc (f x) (list (pair f g) y) =
            if ∃z. MEM (x,z) y then pair f g (HD (FILTER ($= x o FST) y))
            else nil)

   [booleanp_sortedcar]  Theorem

      |- ∀x. |= booleanp (sorted_car x)

   [consp_list_to_sexp]  Theorem

      |- ((consp (list_to_sexp f b) = nil) ⇔ (b = [])) ∧
         ((consp (list_to_sexp f b) = sym "COMMON-LISP" "NIL") ⇔ (b = []))

   [fdom_rewrite]  Theorem

      |- ∀y x.
           ONE_ONE f ⇒
           (bool (x ∈ FDOM y) =
            not (equal nil (assoc (f x) (encode_fmap f g y))))

   [fempty_rewrite]  Theorem

      |- ∀f g. encode_fmap f g FEMPTY = list (pair f g) []

   [fold_FEMPTY]  Theorem

      |- ∀f v. fold f v FEMPTY = v

   [fold_def]  Theorem

      |- ∀v map f.
           fold f v map =
           if map = FEMPTY then v
           else
             (let x = @x. x ∈ FDOM map
              in
                f (x,map ' x) (fold f v (map \\ x)))

   [fold_ind]  Theorem

      |- ∀P.
           (∀f v map.
              (∀x.
                 map ≠ FEMPTY ∧ (x = @x. x ∈ FDOM map) ⇒
                 P f v (map \\ x)) ⇒
              P f v map) ⇒
           ∀v v1 v2. P v v1 v2

   [fupdate_rewrite]  Theorem

      |- ∀x f g m.
           ONE_ONE f ⇒
           (encode_fmap f g (m |+ x) =
            ains (pair f g x) (encode_fmap f g m))

   [insert_def]  Theorem

      |- (∀y x R. insert R (x,y) [] = [(x,y)]) ∧
         ∀y x tl hy hx R.
           insert R (x,y) ((hx,hy)::tl) =
           if hx = x then (x,y)::tl
           else if R x hx then (x,y)::(hx,hy)::tl
           else (hx,hy)::insert R (x,y) tl

   [insert_ind]  Theorem

      |- ∀P.
           (∀R x y. P R (x,y) []) ∧
           (∀R x y hx hy tl.
              (hx ≠ x ∧ ¬R x hx ⇒ P R (x,y) tl) ⇒
              P R (x,y) ((hx,hy)::tl)) ⇒
           ∀v v1 v2 v3. P v (v1,v2) v3

   [ite_rewrites]  Theorem

      |- (ite nil a b = b) ∧ (ite t a b = a)

   [not_nil]  Theorem

      |- not nil = t

   [sorted_car_def]  Theorem

      |- ∀a.
           sorted_car a =
           ite (andl [consp a; consp (cdr a)])
             (andl
                [not (equal (caar a) (caadr a));
                 lexorder (caar a) (caadr a); sorted_car (cdr a)]) t

   [sorted_car_distinct]  Theorem

      |- ∀x.
           (sorted_car x = t) ⇒
           ALL_DISTINCT (MAP FST (sexp_to_list (sexp_to_pair I I) x))

   [sorted_car_ind]  Theorem

      |- ∀P.
           (∀a. (andl [consp a; consp (cdr a)] ≠ nil ⇒ P (cdr a)) ⇒ P a) ⇒
           ∀v. P v

   [sorted_car_rewrite]  Theorem

      |- ∀x.
           bool
             ((MAPSET ($<= LEX K (K T)) o sexp_to_list (sexp_to_pair I I))
                x) =
           sorted_car x

   [sorted_car_sorted]  Theorem

      |- ∀x.
           (sorted_car x = t) ⇒
           SORTED ($<= LEX K (K T)) (sexp_to_list (sexp_to_pair I I) x)


*)
end
