;(ld "/home/waqar/Downloads/HOL-ACL2 Code/alter_seq_error_bound/alter-seq-error-bound.lisp")

;Use Exponential for functional Instantiation


(defun FACT-1 (n)
  (declare (xargs :guard  (natp n)))
  (if (zp n)
      1
    (* n (FACT-1 (- n 1)))))
#||
(defthm expt-decreases
  (implies (and (natp n)
                (rationalp x)
                (< 0 x)
                (< x (+ n 1)))
           (< (/ (expt x (+ n 1))
                 (FACT-1 (+ n 1)))
              (/ (expt x n)
                 (FACT-1 n)))))
||#
(defun expt-div-fact (x n)
  (declare (xargs :guard  (and (rationalp x)
                               (< 0 x)
                               (natp n))))
  (/ (expt x n)
     (FACT-1 n)))

(defthm expt-div-fact-pos
  (implies (and (natp n)
                (rationalp x)
                (< 0 x))
           (and (rationalp (expt-div-fact x n))
                (< 0 (expt-div-fact x n)))))

(defthm expt-div-fact-decreases
  (implies (and (natp n)
                (rationalp x)
                (< 0 x)
                (< x n))
           (< (expt-div-fact x (+ 1 n))
              (expt-div-fact x n))))


(in-theory (disable expt-div-fact))

(defund expt-minus-maclaurin (x m n)
  (declare (xargs :guard (and (natp n) (natp m)) :verify-guards nil))
  (if (zp n)
      (* (minus-1 m)
         (expt-div-fact x m))
    (+ (* (minus-1 (+ m n))
          (expt-div-fact x (+ m n)))
       (expt-minus-maclaurin x m (+ -1 n)))))


(defthm abs-expt-error-bound-lemma-1
  (implies (and (zp n)
                (acl2-numberp m))
           (equal (expt-minus-maclaurin x m n)
                  (* (minus-1 m)
                     (expt-div-fact x m))))
  :hints (("Goal" :in-theory (enable expt-minus-maclaurin))))

(defthm abs-expt-error-bound
  (implies (and (rationalp x)
                (< 0 x)
                (natp m)
                (natp n)
                (< x m)
                (<= (big-index) m))
           (<= (abs (- (expt-minus-maclaurin x 0 (+ m 1 n))
                       (expt-minus-maclaurin x 0 m)))
               (expt-div-fact x (+ m 1))))
  :hints (("Goal"
           :do-not-induct t
           #||
           :in-theory (disable abs
           expt
           EXPT-MINUS-MACLAURIN
           minus-1)
           ||#
           :in-theory (enable expt-minus-maclaurin)
           :use
           ((:instance (:functional-instance
                        abs-n-term-sum-split1-lt-n-term3
                        (n-term (lambda (n2)
                                  (if (and (natp m)
                                           (< x m)
                                           (rationalp x)
                                           (< 0 x))
                                      (expt-div-fact x n2)
                                    (n-term n2))))
                        (big-index (lambda ()
                                     (if (and (natp m)
                                              (<= (big-index) m))
                                         m
                                       (big-index))))
                        (n-term-sum1 (lambda (m2 n)
                                       (if (and (natp m)
                                                (< x m)
                                                (rationalp x)
                                                (< 0 x))
                                           (expt-minus-maclaurin x m2 n)
                                         (n-term-sum1 m2 n))))
                        )))))
  :otf-flg t)

(defthm abs-expt-error-bound1
  (implies (and (rationalp x)
                (< 0 x)
                (natp k)
                (natp n)
                (< x k)
                (<= (big-index) k))
           (<= (abs (- (expt-minus-maclaurin x 0 (+ k 1 n))
                       (expt-minus-maclaurin x 0 k)))
               (expt-div-fact x (+ k 1))))
  :hints (("Goal"
           :do-not-induct t
#||
           :in-theory (disable abs
                               expt
                               EXPT-MINUS-MACLAURIN
                               minus-1)
||#
           :in-theory (enable expt-minus-maclaurin)
           :use
           ((:instance (:functional-instance
                        abs-n-term-sum-split1-lt-n-term3
                        (n-term (lambda (n2)
                                  (if (and (natp k)
                                           (< x k)
                                           (rationalp x)
                                           (< 0 x))
                                      (expt-div-fact x n2)
                                    (n-term n2))))
                        (big-index (lambda ()
                                     (if (and (natp k)
                                              (<= (big-index) k))
                                         k
                                       (big-index))))
                        (n-term-sum1 (lambda (m2 n)
                                       (if (and (natp k)
                                                (< x k)
                                                (rationalp x)
                                                (< 0 x))
                                           (expt-minus-maclaurin x m2 n)
                                         (n-term-sum1 m2 n)))))
                        (m k)
                       ))))
  :otf-flg t)

(defthm abs-expt-error-bound2
  (implies (and (rationalp x)
                (< 0 x)
                (natp k)
                (natp n)
                (< x k)
                (<= (big-index) k))
           (<= (abs (expt-minus-maclaurin x (+ k 1) n))
               (expt-div-fact x (+ k 1))))
  :hints (("Goal"
           :do-not-induct t
#||
           :in-theory (disable abs
                               expt
                               EXPT-MINUS-MACLAURIN
                               minus-1)
||#
           :in-theory (enable expt-minus-maclaurin)
           :use
           ((:instance (:functional-instance
                        abs-n-term-sum-split1-lt-n-term4
                        (n-term (lambda (n2)
                                  (if (and (natp k)
                                           (< x k)
                                           (rationalp x)
                                           (< 0 x))
                                      (expt-div-fact x n2)
                                    (n-term n2))))
                        (big-index (lambda ()
                                     (if (and (natp k)
                                              (<= (big-index) k))
                                         k
                                       (big-index))))
                        (n-term-sum1 (lambda (m2 n)
                                       (if (and (natp k)
                                                (< x k)
                                                (rationalp x)
                                                (< 0 x))
                                           (expt-minus-maclaurin x m2 n)
                                         (n-term-sum1 m2 n)))))
                        (m k)
                       ))))
  :otf-flg t)

#||
(defthm abs-expt-error-bound3
  (implies (and (rationalp x)
                (< 0 x)
                (natp k)
                (natp n)
                (< x k)
                (<= (big-index) (- k 1)))
           (<= (abs (expt-minus-maclaurin x k n))
               (expt-div-fact x (+ k 1))))
  :hints (("Goal"
           :do-not-induct t
#||
           :in-theory (disable abs
                               expt
                               EXPT-MINUS-MACLAURIN
                               minus-1)
||#
           :in-theory (enable expt-minus-maclaurin)
           :use
           ((:instance abs-expt-error-bound2
                       (k (- k 1))))
)))

||#

