(defthm abs-expt-error-bound-tri-10
  (implies (and (rationalp x1)
                (rationalp x2)
                (rationalp x3)
                (rationalp x4)
                (< 0 x1)
                (< 0 x2)
                (< 0 x3)
                (< 0 x4)
                (natp k)
                (natp n)
                (< x1 k)
                (< x2 k)
                (< x3 k)
                (< x4 k))
           (<= (abs (- (+ (expt-minus-maclaurin x1 0 (+ k 1 n))
                          (* (expt-minus-maclaurin x2 0 (+ k 1 n))
                             (- 1 (expt-minus-maclaurin x3 0 (+ k 1 n))))
                          (-(expt-minus-maclaurin x4 0 (+ k 1 n))))
                       (+ (expt-minus-maclaurin x1 0 k)
                          (* (expt-minus-maclaurin x2 0 k)
                             (- 1 (expt-minus-maclaurin x3 0 k)))
                          (-(expt-minus-maclaurin x4 0 k)))))
               (+ (expt-div-fact x1 (+ k 1))
                  (expt-div-fact x2 (+ k 1))
                  (* (abs (expt-minus-maclaurin x3 0 k))
                     (expt-div-fact x2 (+ k 1)))
                  (* (abs (expt-minus-maclaurin x2 0 (+ k 1 n)))
                     (expt-div-fact x3 (+ k 1)))
                  (expt-div-fact x4 (+ k 1)))))
  :hints (("Goal"
           :use
           ((:functional-instance abs-expt-error-bound-tri-9
                                  (big-index big-index-simple)
                                  (n-term n-term-simple)))
           :in-theory (disable abs-expt-error-bound-tri-9))))



(defthm abs-expt-error-bound-tri-10-instance
  (let ((x1 1/2) (x2 1/3) (x3 1/4) (x4 1/5) (k 10) (n 10))
    (< (abs (- (+ (expt-minus-maclaurin x1 0 (+ k 1 n))
                  (* (expt-minus-maclaurin x2 0 (+ k 1 n))
                     (- 1 (expt-minus-maclaurin x3 0 (+ k 1 n))))
                  (-(expt-minus-maclaurin x4 0 (+ k 1 n))))
               (+ (expt-minus-maclaurin x1 0 k)
                  (* (expt-minus-maclaurin x2 0 k)
                     (- 1 (expt-minus-maclaurin x3 0 k)))
                  (-(expt-minus-maclaurin x4 0 k)))))
       (/ 12353379 (expt 10 11))))
  :rule-classes nil)



(defthm test3333
  (implies (and (rationalp aa)
                (rationalp bb)
                (rationalp dd)
                (rationalp ee)
                (< 0 aa)
                (< 0 bb)
                (< 0 dd)
                (< 0 ee))
           (equal (- (- 1 (* (- 1 aa)
                             (- 1 bb)
                             ))
                     (- 1 (* (- 1 dd)
                             (- 1 ee)
                             )))
                  (- (* (- 1 dd)
                        (- 1 ee)
                        )
                     (* (- 1 aa)
                        (- 1 bb)
                        )))))


(defthm test1
  (implies (and (rationalp x1)
                (rationalp x2)
                (< 0 x1)
                (< 0 x2)
                (natp k)
                (natp n)
                (< x1 k)
                (< x2 k))
           (equal (- (- 1 (* (- 1 (expt-minus-maclaurin x1 0 k))
                             (- 1 (expt-minus-maclaurin x2 0 k))
                             ))
                     (- 1 (* (- 1 (expt-minus-maclaurin x1 0 (+ k 1 n)))
                             (- 1 (expt-minus-maclaurin x2 0 (+ k 1 n)))
                             )))
                  (+ (expt-minus-maclaurin x2 0 (+ k 1 n))
                     (expt-minus-maclaurin x1 0 (+ k 1 n))
                     (* (-(expt-minus-maclaurin x1 0 (+ k 1 n))) 
                        (expt-minus-maclaurin x2 0 (+ k 1 n)))
                     (-(expt-minus-maclaurin x1 0 k)) 
                     (-(expt-minus-maclaurin x2 0 k)) 
                     (* (expt-minus-maclaurin x1 0 k) 
                        (expt-minus-maclaurin x2 0 k))))))


(defthm test3333
  (implies (and (rationalp aa)
                (rationalp bb)
                (rationalp cc)
                (rationalp dd)
                (rationalp ee)
                (rationalp ff)
                (< 0 aa)
                (< 0 bb)
                (< 0 cc)
                (< 0 dd)
                (< 0 ee)
                (< 0 ff))
           (equal (abs (- (- 1 (* (+ 1 -aa)
                                  (+ 1 -bb)
                                  (+ 1 -cc)))
                          (- 1 (* (+ 1 -dd)
                                  (+ 1 -ee)
                                  (+ 1 -ff)))))
                  (+ abs (- bb ee)
                     abs (- aa dd)
                     abs (- (* aa bb)
                            (* dd ee))
                     abs (- cc ff)
                     abs (- (* cc bb)
                            (* ff ee))
                     abs (- (* aa cc)
                            (* dd ff))
                     abs (- (* aa bb cc)
                            (* dd ee ff))))))



(defthm test2
  (implies (and (rationalp x1)
                (rationalp x2)
                (rationalp x3)
                (< 0 x1)
                (< 0 x2)
                (< 0 x3)
                (natp k)
                (natp n)
                (< x1 k)
                (< x2 k)
                (< x3 k))
           (<= (abs (- (- 1 (* (+ 1 
                                  (-(expt-minus-maclaurin x1 0 (+ k 1 n))))
                               (+ 1 
                                  (-(expt-minus-maclaurin x2 0 (+ k 1 n))))
                               (+ 1 
                                  (-(expt-minus-maclaurin x3 0 (+ k 1 n))))))
                       (- 1 (* (+ 1 (-(expt-minus-maclaurin x1 0 k)))
                               (+ 1 (-(expt-minus-maclaurin x3 0 k)))
                               (+ 1 (-(expt-minus-maclaurin x3 0 k)))))))
               (+ (abs (+ (expt-minus-maclaurin x1 0 (+ k 1 n)) 
                          (-(expt-minus-maclaurin x1 0 k))))
                  (abs (+ (expt-minus-maclaurin x2 0 (+ k 1 n)) 
                          (-(expt-minus-maclaurin x2 0 k))))
                  (* (abs (expt-minus-maclaurin x1 0 (+ k 1 n)))
                     (abs (+ (expt-minus-maclaurin x2 0 (+ k 1 n)) 
                             (-(expt-minus-maclaurin x2 0 k)))))
                  (* (abs (expt-minus-maclaurin x2 0 k))
                     (abs (+ (expt-minus-maclaurin x1 0 (+ k 1 n)) 
                             (-(expt-minus-maclaurin x1 0 k)))))
                  (abs (+ (expt-minus-maclaurin x3 0 (+ k 1 n)) 
                          (-(expt-minus-maclaurin x3 0 k))))
                  (* (abs (expt-minus-maclaurin x3 0 (+ k 1 n)))
                     (abs (+ (expt-minus-maclaurin x2 0 (+ k 1 n)) 
                             (-(expt-minus-maclaurin x2 0 k)))))
                  (* (abs (expt-minus-maclaurin x2 0 k))
                     (abs (+ (expt-minus-maclaurin x3 0 (+ k 1 n)) 
                             (-(expt-minus-maclaurin x3 0 k)))))
                  (* (abs (expt-minus-maclaurin x1 0 (+ k 1 n)))
                     (abs (expt-minus-maclaurin x2 0 k))
                     (abs (+ (expt-minus-maclaurin x3 0 (+ k 1 n)) 
                             (-(expt-minus-maclaurin x3 0 k)))))
                  (* (abs (expt-minus-maclaurin x3 0 k))
                     (abs (expt-minus-maclaurin x1 0 (+ k 1 n)))
                     (abs (+ (expt-minus-maclaurin x2 0 (+ k 1 n)) 
                             (-(expt-minus-maclaurin x2 0 k)))))
                  (* (abs (expt-minus-maclaurin x2 0 k))
                     (abs (+ (expt-minus-maclaurin x1 0 (+ k 1 n)) 
                             (-(expt-minus-maclaurin x1 0 k)))))
                  (* (abs (expt-minus-maclaurin x3 0 k))
                     (abs (expt-minus-maclaurin x2 0 k))
                     (abs (+ (expt-minus-maclaurin x1 0 (+ k 1 n)) 
                             (-(expt-minus-maclaurin x1 0 k)))))
                  (* (abs (expt-minus-maclaurin x3 0 k))
                     (abs (expt-minus-maclaurin x1 0 (+ k 1 n)))
                     (abs (+ (expt-minus-maclaurin x2 0 (+ k 1 n)) 
                             (-(expt-minus-maclaurin x2 0 k)))))))))



(defthm test2
  (implies (and (rationalp x1)
                (rationalp x2)
                (rationalp x3)
                (< 0 x1)
                (< 0 x2)
                (< 0 x3)
                (natp k)
                (natp n)
                (< x1 k)
                (< x2 k)
                (< x3 k))
           (<= (abs (- (- 1 
                          (* (+ 1 
                                (-(expt-minus-maclaurin x1 0 (+ k 1 n))))
                             (+ 1 
                                (-(expt-minus-maclaurin x2 0 (+ k 1 n))))
                             (+ 1 
                                (-(expt-minus-maclaurin x3 0 (+ k 1 n))))))
                       (- 1 
                          (* (+ 1 (-(expt-minus-maclaurin x1 0 k)))
                             (+ 1 (-(expt-minus-maclaurin x3 0 k)))
                             (+ 1 (-(expt-minus-maclaurin x3 0 k)))))))
               (+ (expt-div-fact x1 (+ k 1))
                  (expt-div-fact x2 (+ k 1))
                  (* (abs (expt-minus-maclaurin x1 0 (+ k 1 n)))
                     (expt-div-fact x2 (+ k 1)))
                  (* (abs (expt-minus-maclaurin x2 0 k))
                     (expt-div-fact x1 (+ k 1)))
                  (abs (expt-div-fact x3 (+ k 1)))
                  (* (abs (expt-minus-maclaurin x3 0 (+ k 1 n)))
                     (abs (expt-div-fact x2 (+ k 1))))
                  (* (abs (expt-minus-maclaurin x2 0 k))
                     (expt-div-fact x3 (+ k 1)))
                  (* (abs (expt-minus-maclaurin x1 0 (+ k 1 n)))
                     (abs (expt-minus-maclaurin x2 0 k))
                     (expt-div-fact x3 (+ k 1)))
                  (* (abs (expt-minus-maclaurin x3 0 k))
                     (abs (expt-minus-maclaurin x1 0 (+ k 1 n)))
                     (expt-div-fact x2 (+ k 1)))
                  (* (abs (expt-minus-maclaurin x2 0 k))
                     (expt-div-fact x1 (+ k 1)))
                  (* (abs (expt-minus-maclaurin x3 0 k))
                     (abs (expt-minus-maclaurin x2 0 k))
                     (expt-div-fact x1 (+ k 1)))
                  (* (abs (expt-minus-maclaurin x3 0 k))
                     (abs (expt-minus-maclaurin x1 0 (+ k 1 n)))
                     (expt-div-fact x2 (+ k 1)))))))
