(* ========================================================================= *)
(* File Name: HOL_sexp_equiv_expfuncScript.sml	                                     *)
(*---------------------------------------------------------------------------*)
(* Description: Proving the Equivalence of Exponential Function Defined	     *)
(*           at HOL with its Equivalent Representation in SexpTheory         *)
(*                                                                           *)
(*                HOL4-Kananaskis 10 		 			     *)
(*									     *)
(*		Author :  Waqar Ahmad             		     	     *)
(*                                              			     *)
(* 	    School of Electrical Engineering and Computer Sciences (SEECS)   *)
(*	    National University of Sciences and Technology (NUST), PAKISTAN  *)
(*                                          		               	     *)
(*                                                                           *)
(* ========================================================================= *)

(*---------HOL to ACL2 exponential--------------*)

loadPath := "/home/waqar/Downloads/acl2-link/acl2-link/ml" :: !loadPath;
loadPath := "/home/waqar/Downloads/HOL-Code-thesis/Formal-Dependability" :: !loadPath;
app load ["arithmeticTheory","intExtensionTheory","extendTranslateTheory", "sexpTheory", 
           "translateTheory","intLib","ratLib","complex_rationalTheory", "acl2encodeLib","dep_rewrite","hol_defaxiomsTheory","fracTheory","translateLib"];

open arithmeticTheory intExtensionTheory extendTranslateTheory sexpTheory translateTheory 
     	intLib ratLib complex_rationalTheory acl2encodeLib dep_rewrite hol_defaxiomsTheory fracTheory translateLib;
(*load "acl2encodeLib";
open acl2encodeLib;
load "dep_rewrite";
load "hol_defaxiomsTheory";
load "fracTheory";
open dep_rewrite;
open hol_defaxiomsTheory;
open fracTheory; *)
open HolKernel boolLib bossLib Parse;
val _ = new_theory "HOL_sexp_equiv_expfunc";
(*--------------------------------------------*)
(*-------------------------------------------------*)
val exp_ratr_def = tDefine "exp_ratr"
`exp_ratr a n =  
if ((n:int) = 0) then 
  (1:rat) 
else if (0 < (n:int)) then 
  (a * exp_ratr a (n - 1))
else 
  (rat_minv a * exp_ratr a (n + 1))`
(WF_REL_TAC `measure (\a.  (Num(ABS(SND a))))`
THEN RW_TAC int_ss[]
THEN ARITH_TAC THEN ARITH_TAC);
(*-------------------------------------------------*)
(*------------------------*)
val exp_ratr_0 = store_thm("exp_ratr_0",
  ``!a. exp_ratr a 0 = 1``,
GEN_TAC THEN ONCE_REWRITE_TAC[exp_ratr_def]
THEN RW_TAC int_ss[]);

(*------------------------*)
val exp_ratr_suc = store_thm("exp_ratr_suc",
  ``!b a. exp_ratr a (int_of_num (SUC b)) = a * exp_ratr a (&b)``,
REPEAT GEN_TAC
THEN ONCE_REWRITE_TAC[exp_ratr_def]
THEN (`~(int_of_num (SUC b) = 0)` by RW_TAC int_ss[integerTheory.INT,numTheory.NOT_SUC])
THEN ONCE_ASM_REWRITE_TAC[]
THEN REWRITE_TAC[]
THEN (`0 < int_of_num (SUC b)` by RW_TAC int_ss[integerTheory.INT])
THEN ONCE_ASM_REWRITE_TAC[]
THEN REWRITE_TAC[]
THEN REWRITE_TAC[GSYM exp_ratr_def]
THEN RW_TAC int_ss[integerTheory.INT,numTheory.NOT_SUC]
THEN REWRITE_TAC[integerTheory.int_sub]
THEN REWRITE_TAC [GSYM integerTheory.INT_ADD_ASSOC]
THEN RW_TAC int_ss[integerTheory.INT_ADD_RINV]);
(*------------------------------*)
val rat_of_int_alt1 = store_thm("rat_of_int_alt1",
  ``!a. (abs_rat (abs_frac (a,1)) = rat_of_int a)``,
RW_TAC std_ss[] THEN
DEP_REWRITE_TAC[GSYM extendTranslateTheory.rat_of_int_div_pos] THEN
RW_TAC int_ss[] THEN
(`rat_of_int 1 = 1` by RW_TAC std_ss[])
 THEN1 (RW_TAC int_ss[rat_of_int_def]
	       THEN ONCE_ASM_REWRITE_TAC[])
THEN ONCE_ASM_REWRITE_TAC[]
THEN (`(rat_of_int a) / 1 =  rat_of_int a` by DEP_REWRITE_TAC[ratTheory.RAT_LDIV_EQ])
    THEN1 (STRIP_TAC THEN1 RAT_BASIC_ARITH_TAC
		     THEN RW_TAC std_ss[ratTheory.RAT_MUL_LID]));
(*-------------------------------------------------*)
val rat_of_int_alt = store_thm("rat_of_int_alt",
  ``!a. (0 < a) ==> (abs_rat (abs_frac (a,1)) = rat_of_int a)``,

RW_TAC std_ss[] THEN
DEP_REWRITE_TAC[GSYM extendTranslateTheory.rat_of_int_div_pos] THEN
RW_TAC int_ss[] THEN
(`rat_of_int 1 = 1` by RW_TAC std_ss[])
 THEN1 (RW_TAC int_ss[rat_of_int_def]
	THEN ONCE_ASM_REWRITE_TAC[])
THEN ONCE_ASM_REWRITE_TAC[]
THEN (`(rat_of_int a) / 1 =  rat_of_int a` by DEP_REWRITE_TAC[ratTheory.RAT_LDIV_EQ])
    THEN1 (STRIP_TAC THEN1 RAT_BASIC_ARITH_TAC
		     THEN RW_TAC std_ss[ratTheory.RAT_MUL_LID]));
(*-------------------------------------------------*)
(*-------------------------------------------------*)
val exp_ratr_neg_suc = store_thm("exp_ratr_neg_suc",
  ``!b a. exp_ratr a (-int_of_num (SUC b)) = rat_minv a * exp_ratr a (-&b)  ``,
REPEAT GEN_TAC
THEN ONCE_REWRITE_TAC[exp_ratr_def]
THEN (`~(-int_of_num (SUC b) = 0)` by RW_TAC int_ss[integerTheory.INT,numTheory.NOT_SUC])
THEN ONCE_ASM_REWRITE_TAC[]
THEN REWRITE_TAC[]
THEN (`~(0 < -int_of_num (SUC b))` by RW_TAC int_ss[integerTheory.INT])
THEN ONCE_ASM_REWRITE_TAC[]
THEN REWRITE_TAC[]
THEN REWRITE_TAC[GSYM exp_ratr_def]
THEN RW_TAC int_ss[integerTheory.INT,GSYM integerTheory.INT_SUB_LNEG]);

(*-------------------------------------------------*)

val zip_int_SUC_nil = store_thm("zip_int_not_nil",
  ``!x b.  zip (int (&SUC b)) = nil  ``,
RW_TAC std_ss[nat_def,GSYM INT_THMS,nat_def,ite_def,TRUTH_REWRITES,hol_defaxiomsTheory.zip_def,
    	   INTEGERP_INT,GSYM int_def,integerTheory.int_exp,FIX_INT,
	   integerTheory.INT_ADD_CALCULATE]
THEN RW_TAC int_ss[]);
(*-------------------------------------------------*)
(*------------------------------------------------*)
val rat_0_eq_rat_of_int0 = store_thm("rat_0_eq_rat_of_int0",
  ``rat_0 = rat_of_int 0  ``,
RW_TAC std_ss[rat_of_int_def] THEN
RW_TAC std_ss[extendTranslateTheory.NUM_OF_ABS,intExtensionTheory.INT_ABS_CALCULATE_0] THEN
(MATCH_MP_TAC EQ_SYM) THEN
RW_TAC int_ss [ratTheory.RAT_0] THEN
RW_TAC int_ss[integerTheory.INT_OF_NUM] THEN
FULL_SIMP_TAC int_ss[]);
(*---------------------------------------*)
val rat_of_int_eq_rat = store_thm("rat_of_int_eq_rat",
  ``!a. rat_of_int a = rat a 1``,
RW_TAC std_ss[sexpTheory.rat_def]
THEN RW_TAC std_ss[GSYM rat_of_int_alt1]);

(*------------------*)
val rat_int_cov = store_thm("rat_int_cov",
  ``!a. rat (rat_of_int a) =  int a  ``,
RW_TAC int_ss[int_def,cpx_def]
THEN RW_TAC std_ss[GSYM rat_of_int_eq_rat]
THEN RW_TAC std_ss[GSYM rat_0_eq_rat_of_int0]
THEN RW_TAC std_ss[GSYM rat_def]);
(*------------------*)
val int_rat_conv = store_thm("int_rat_conv",
  ``!a. rat (rat_of_int (int_of_num a)) = int (int_of_num a)``,
PROVE_TAC[rat_int_cov]);
(*------------------*)
val rat_1_eq_rat_of_int1 = store_thm("rat_1_eq_rat_of_int1",
  ``rat_1 = rat_of_int 1  ``,
RW_TAC std_ss[rat_of_int_def] THEN
DEP_REWRITE_TAC[extendTranslateTheory.NUM_OF_ABS,intExtensionTheory.INT_ABS_CALCULATE_POS] THEN
RW_TAC int_ss [ratTheory.RAT_1] THEN
FULL_SIMP_TAC int_ss[]);

(*------------------*)
val rat_eq_int_1 = store_thm("rat_eq_int_1",
  ``rat 1 = int 1  ``,
RW_TAC std_ss[translateTheory.rat_def,int_def,cpx_def]
THEN1 (RW_TAC std_ss[sexpTheory.rat_def,rat_of_int_alt1]
       THEN RW_TAC std_ss[GSYM rat_1_eq_rat_of_int1]
       THEN RW_TAC std_ss[ratTheory.RAT_1])
THEN RW_TAC std_ss[sexpTheory.rat_def,rat_of_int_alt1,rat_0_eq_rat_of_int0]);

(*------------------*)
val rat_eq_int = store_thm("rat_eq_int",
  ``rat 0 = int 0  ``,
RW_TAC std_ss[rat_def,int_def,cpx_def]
THEN1 (RW_TAC std_ss[GSYM rat_of_int_eq_rat,GSYM rat_0_eq_rat_of_int0]
      THEN RW_TAC std_ss[ratTheory.RAT_0])
      THEN (RW_TAC std_ss[GSYM rat_of_int_eq_rat,GSYM rat_0_eq_rat_of_int0]
      THEN RW_TAC std_ss[ratTheory.RAT_0]));

(*------------------*)
val zip_int_SUC_nil = store_thm("zip_int_not_nil",
  ``!x b.  zip (int (&SUC b)) = nil  ``,
RW_TAC std_ss[nat_def,GSYM INT_THMS,nat_def,ite_def,TRUTH_REWRITES,hol_defaxiomsTheory.zip_def,
    	   INTEGERP_INT,GSYM int_def,integerTheory.int_exp,FIX_INT,
	   integerTheory.INT_ADD_CALCULATE]
THEN RW_TAC int_ss[]);

(*-------------------------------------------------*)

val zip_int_SUC_neg_nil = store_thm("zip_int_suc_neg_nil",
  ``!x b.  zip (int (~&SUC b)) = nil  ``,
RW_TAC std_ss[nat_def,GSYM INT_THMS,nat_def,ite_def,TRUTH_REWRITES,zip_def,
    	   INTEGERP_INT,GSYM int_def,integerTheory.int_exp,FIX_INT,
	   integerTheory.INT_ADD_CALCULATE]
THEN RW_TAC int_ss[]);

(*-------------------------------------------*)
val rat_minv_inv = store_thm("rat_minv_inv",
  ``!a. ~(a = 0) ==> (rat_minv a = 1 / a)  ``,
GEN_TAC
THEN (`rat_minv a = 1 * rat_minv a` by RW_TAC int_ss[ratTheory.RAT_MUL_LID])
THEN ONCE_ASM_REWRITE_TAC[]
THEN DEP_REWRITE_TAC[GSYM ratTheory.RAT_DIV_MULMINV]);

(*--------------------------------------------*)
(*val int_reciprocal = store_thm("int_reciprocal",
  ``!a. ~(a = 0) ==> (reciprocal (int &a) = int (1 / &a))``,
THEN RW_TAC std_ss[sexpTheory.reciprocal_def]
THEN DEP_REWRITE_TAC[integerTheory.int_div]
THEN RW_TAC int_ss[]
THEN REWRITE_TAC[GSYM rat_int_cov]
THEN RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[rat_reciprocal]
THEN ONCE_REWRITE_TAC[rat_of_int_def]
THEN RW_TAC std_ss[translateTheory.rat_def]
THEN RW_TAC std_ss[sexpTheory.reciprocal_def]
THEN DEP_REWRITE_TAC[arithmeticTheory.X_LT_DIV] *)
(*--------------------------------------------*)
val rat_reciprocal = store_thm("rat_reciprocal",
  ``!a. ~(a =0) ==> (reciprocal (rat a) = rat (rat_minv a))``,
RW_TAC std_ss[translateTheory.rat_def]
THEN RW_TAC std_ss[sexpTheory.reciprocal_def]
THEN1 (FULL_SIMP_TAC std_ss[complex_rationalTheory.com_0_def,complex_rational_11,ratTheory.RAT_0])
THEN RW_TAC std_ss[COMPLEX_RECIPROCAL_def,
    	   ratTheory.rat_0_def,GSYM ratTheory.rat_0,COMPLEX_MULT_def,ratTheory.RAT_MUL_RZERO,
	   ratTheory.RAT_ADD_RID,ratTheory.RAT_MUL_LZERO,ratTheory.RAT_ADD_LID,ratTheory.RAT_AINV_0,int_def,
	   ratTheory.RAT_SUB_RID]
THEN1 (DEP_REWRITE_TAC[rat_minv_inv]
       THEN RW_TAC std_ss[]
       THEN DEP_REWRITE_TAC[ratTheory.RAT_LDIV_EQ] 
       THEN RW_TAC std_ss[ratTheory.RAT_NO_ZERODIV_NEG]
       THEN REWRITE_TAC[GSYM ratTheory.RAT_MUL_ASSOC]
       THEN RW_TAC std_ss[GSYM rat_minv_inv]	
       THEN RW_TAC std_ss[ratTheory.RAT_MUL_RINV,ratTheory.RAT_MUL_RID])
THEN RW_TAC std_ss[ratTheory.RAT_MUL_RZERO]
THEN RW_TAC std_ss[ratTheory.RAT_ADD_RID]
THEN DEP_REWRITE_TAC[ratTheory.RAT_LDIV_EQ] 
THEN RW_TAC std_ss[ratTheory.RAT_NO_ZERODIV_NEG]
THEN REWRITE_TAC[GSYM ratTheory.RAT_MUL_ASSOC]
THEN REWRITE_TAC[ratTheory.RAT_MUL_RZERO]
THEN RW_TAC std_ss[ratTheory.RAT_AINV_0]);
(*-------------------------------------------------*)
val exp_ratr_thm = store_thm("exp_ratr_thm",
  ``!b a. ~(a =0) ==> (rat (exp_ratr a b) =  acl2_expt (rat a) (int b))``,
Cases 
THEN1 (Induct_on `n`
      THEN1 (REWRITE_TAC[])
      THEN RW_TAC arith_ss[]
      THEN RW_TAC int_ss[exp_ratr_suc]
      THEN ONCE_REWRITE_TAC[acl2_expt_def]
      THEN REWRITE_TAC[zip_int_SUC_nil]
      THEN REWRITE_TAC[FIX_NUM]
      THEN (`(equal (rat a) (int 0)) = (bool (a = 0)) ` by REWRITE_TAC[])
      THEN1 (REWRITE_TAC[GSYM rat_int_cov]
	     THEN REWRITE_TAC[GSYM rat_0_eq_rat_of_int0]
	     THEN REWRITE_TAC[GSYM RAT_THMS,ratTheory.RAT_0])
      THEN ONCE_ASM_REWRITE_TAC[]
      THEN RW_TAC int_ss [nat_def,GSYM INT_THMS,nat_def,GSYM RAT_THMS,ite_def,TRUTH_REWRITES,zip_def,
    	   INTEGERP_INT,GSYM int_def,integerTheory.int_exp,FIX_INT,
	   integerTheory.INT_ADD_CALCULATE,FIX_NUM]
      THEN1 (FULL_SIMP_TAC int_ss [integerTheory.int_gt,integerTheory.INT_LT_CALCULATE])
      THEN (RW_TAC int_ss [RAT_MULT]
	      THEN RW_TAC int_ss[integerTheory.int_of_num,integerTheory.INT_1]
	      THEN RW_TAC int_ss [GSYM int_arithTheory.INT_SUB_SUB3]
	      THEN Cases_on `n`
              THEN1 (RW_TAC std_ss[exp_ratr_0]
		     THEN ONCE_REWRITE_TAC[acl2_expt_def]
		     THEN RW_TAC int_ss [nat_def,GSYM INT_THMS,nat_def,ite_def,TRUTH_REWRITES,zip_def,
    	   INTEGERP_INT,GSYM int_def,integerTheory.int_exp,FIX_INT,
	   integerTheory.INT_ADD_CALCULATE]
	             THEN RW_TAC std_ss[rat_eq_int_1])
	      THEN FULL_SIMP_TAC arith_ss[]))
THEN1 (GEN_TAC
      THEN Induct_on `n`
      THEN1 (RW_TAC std_ss[])
      THEN RW_TAC arith_ss[]
      THEN REWRITE_TAC[exp_ratr_neg_suc]
      THEN ONCE_REWRITE_TAC[acl2_expt_def]
      THEN REWRITE_TAC[zip_int_SUC_neg_nil]
      THEN REWRITE_TAC[FIX_NUM]
      THEN (`(equal (rat a) (int 0)) = (bool (a = 0)) ` by REWRITE_TAC[])
      THEN1 (REWRITE_TAC[GSYM rat_int_cov]
	     THEN REWRITE_TAC[GSYM rat_0_eq_rat_of_int0]
	     THEN REWRITE_TAC[GSYM RAT_THMS,ratTheory.RAT_0])
      THEN ONCE_ASM_REWRITE_TAC[]
      THEN (`less (int 0) (int (-&SUC n)) = nil` by ALL_TAC)
      THEN1 (RW_TAC int_ss[GSYM INT_THMS,integerTheory.int_gt,integerTheory.INT_LT_CALCULATE,bool_def])
      THEN ONCE_ASM_REWRITE_TAC[]
      THEN REWRITE_TAC[]
      THEN RW_TAC int_ss [nat_def,GSYM INT_THMS,nat_def,GSYM RAT_THMS,ite_def,TRUTH_REWRITES,zip_def,
    	   INTEGERP_INT,GSYM int_def,integerTheory.int_exp,FIX_INT,
	   integerTheory.INT_ADD_CALCULATE,FIX_NUM]
      THEN1 (RW_TAC int_ss [RAT_MULT]
	      THEN RW_TAC int_ss[rat_int_cov,GSYM INT_THMS]
	      THEN RW_TAC std_ss[arithmeticTheory.ADD1]
	      THEN ONCE_REWRITE_TAC[arithmeticTheory.ADD_SYM]
	      THEN RW_TAC arith_ss[arithmeticTheory.ADD1,arithmeticTheory.SUB_PLUS]
	      THEN RW_TAC std_ss[GSYM rat_reciprocal]
	      THEN NTAC 2 (POP_ASSUM MP_TAC)
	      THEN ONCE_ASM_REWRITE_TAC[arithmeticTheory.ONE]
	      THEN ASM_REWRITE_TAC[arithmeticTheory.LESS_EQ_MONO]
	      THEN RW_TAC arith_ss[]
	      THEN RW_TAC int_ss[]
	      THEN REWRITE_TAC[exp_ratr_0]
	      THEN ONCE_REWRITE_TAC[acl2_expt_def]
	      THEN RW_TAC int_ss [nat_def,GSYM INT_THMS,nat_def,ite_def,TRUTH_REWRITES,zip_def,
    	   INTEGERP_INT,GSYM int_def,integerTheory.int_exp,FIX_INT,
	   integerTheory.INT_ADD_CALCULATE]
	      THEN RW_TAC std_ss[rat_eq_int_1])
      THEN (FULL_SIMP_TAC int_ss [integerTheory.int_gt,integerTheory.INT_LT_CALCULATE]
	      THEN POP_ASSUM MP_TAC
	      THEN ONCE_ASM_REWRITE_TAC[arithmeticTheory.ONE]
	      THEN ASM_REWRITE_TAC[GSYM arithmeticTheory.LESS_EQ]
	      THEN RW_TAC std_ss[RAT_THMS]
	      THEN RW_TAC std_ss[GSYM rat_reciprocal]))
THEN REWRITE_TAC [exp_ratr_0]
THEN ONCE_REWRITE_TAC[acl2_expt_def]
THEN RW_TAC int_ss [nat_def,GSYM INT_THMS,nat_def,ite_def,TRUTH_REWRITES,zip_def,INTEGERP_INT,GSYM int_def,integerTheory.int_exp,FIX_INT,
	   integerTheory.INT_ADD_CALCULATE]
THEN RW_TAC std_ss[rat_eq_int_1]);


(*---------------------------------------*)
val minus_1_def = Define `minus_1 n = 
    if (EVEN n) then (1:rat) else (-1)`;


val expt_macl_def = Define 
  `expt_macl x m n =
   if (n = 0) then 
     (minus_1 m * (exp_ratr x &m) / &FACT m)
   else if (0 < n) then 
     ((minus_1 (m + n) * (exp_ratr x &(m + n)/ &FACT (m + n))) + expt_macl x m &(n - 1))
   else 0`;

val acl2_minus_1_def = Define 
`acl2_minus_1 n = 
  ite (acl2_evenp n) (int 1) (unary_minus (int 1))`;
(*
load "translateLib";
open translateLib;
*)
val CHOOSEP_TAC = 
translateLib.CHOOSEP_TAC
[INT_OF_SEXP_TO_INT,NAT_OF_SEXP_TO_NAT];


val acl2_FACT_def = tDefine "acl2_FACT" 
`acl2_FACT n = 
 if zip n = nil then
  (if less (int 0) n = nil then (int 1)
   else (mult (n) (acl2_FACT (add n (unary_minus (int 1))))))
 else int 1 `
(WF_REL_TAC `measure (\a. Num (ABS (sexp_to_int a)))` THEN
RW_TAC std_ss [] THEN
    FULL_SIMP_TAC std_ss [zip_def,TRUTH_REWRITES,ite_def,GSYM int_def] 
THEN FULL_SIMP_TAC std_ss [zip_def,TRUTH_REWRITES,ite_def,GSYM int_def] THEN
CHOOSEP_TAC THEN
    FULL_SIMP_TAC int_ss [GSYM INT_THMS,TRUTH_REWRITES,SEXP_TO_INT_OF_INT] THEN
    ONCE_REWRITE_TAC [GSYM integerTheory.INT_LT] THEN
    REWRITE_TAC [NUM_OF_ABS] THEN
    ARITH_TAC);


val acl2_expt_macl_def = tDefine "acl2_expt_macl"
  `acl2_expt_macl x m n =
   if zip n = nil then
   ite (equal (fix x) (int 0)) (int 0)
     (if less (int 0) n = nil then (int 0)
        else (add (mult (acl2_minus_1 (add n m)) 
                     (mult (reciprocal (acl2_FACT (add n m))) 
                           (acl2_expt x (add n m))))
               (acl2_expt_macl x m (add n (unary_minus (int 1))))))
    else mult (acl2_minus_1 m)
              (mult (reciprocal (acl2_FACT m)) 
                    (acl2_expt x m))`
(WF_REL_TAC `measure (\a. Num (ABS (sexp_to_int (SND (SND a)))))` THEN
    RW_TAC std_ss [] THEN
    FULL_SIMP_TAC std_ss [zip_def,TRUTH_REWRITES,ite_def,GSYM int_def] THEN
    FULL_SIMP_TAC std_ss [zip_def,TRUTH_REWRITES,ite_def,GSYM int_def] THEN
    CHOOSEP_TAC THEN
    FULL_SIMP_TAC int_ss [GSYM INT_THMS,TRUTH_REWRITES,SEXP_TO_INT_OF_INT] THEN
    ONCE_REWRITE_TAC [GSYM integerTheory.INT_LT] THEN
    REWRITE_TAC [NUM_OF_ABS] THEN
    ARITH_TAC);



(*****************************************************************************)
(* even and odd for natural numbers using acl2 functions evenp and oddp      *)
(*****************************************************************************)
load "ratTheory";
open ratTheory

val nat_rat = store_thm("nat_rat", 
 ``!a. nat a = rat (& a)``,
    RW_TAC std_ss [nat_def,int_def,translateTheory.rat_def,cpx_def,
    	   sexpTheory.rat_def,ratTheory.rat_0_def,frac_0_def,ratTheory.rat_0,ratTheory.RAT_OF_NUM_CALCULATE]);

val int_rat_n = store_thm("int_rat_n",
 ``!a. int (& a) = rat (& a)``,
    RW_TAC std_ss [nat_rat,GSYM nat_def]);

val rat_2_nz = store_thm("rat_2_nz",
``~(0 = 2:rat)``,
    RW_TAC int_ss [ratTheory.RAT_EQ_CALCULATE,ratTheory.RAT_OF_NUM_CALCULATE,NMR,DNM]);

val NAT_EVEN = store_thm("NAT_EVEN",
``!a. bool (EVEN a) = acl2_evenp (nat a)``,
    GEN_TAC THEN
    Cases_on `EVEN a` THEN ASM_REWRITE_TAC [] THEN
    RULE_ASSUM_TAC (ONCE_REWRITE_RULE [GSYM ODD_EVEN]) THEN
    IMP_RES_TAC EVEN_ODD_EXISTS THEN
    RW_TAC int_ss [GSYM nat_def,acl2_evenp_def,nat_rat,
    	   GSYM RAT_DIV,rat_2_nz] THEN
    RW_TAC int_ss [translateTheory.rat_def,integerp_def,
    	   IS_INT_EXISTS,bool_def,TRUTH_REWRITES] THEN
    POP_ASSUM MP_TAC THEN RW_TAC int_ss [ratTheory.RAT_LDIV_EQ,rat_2_nz] THENL [
    	   Q.EXISTS_TAC `& m`,
	   `0 <= c \/ 0 <= ~c` by ARITH_TAC THEN IMP_RES_TAC int_nat_lem THEN
    	   RULE_ASSUM_TAC (CONV_RULE (TRY_CONV
    		   (REWR_CONV (ARITH_PROVE ``(~a = b) = (a = ~b:int)``)))) THEN
           POP_ASSUM SUBST_ALL_TAC] THEN
    RW_TAC int_ss [GSYM FRAC_AINV_CALCULATE,GSYM ratTheory.RAT_AINV_CALCULATE,
    	   GSYM ratTheory.RAT_OF_NUM_CALCULATE,ratTheory.RAT_MUL_NUM_CALCULATE,
	   ratTheory.RAT_EQ_NUM_CALCULATE] THEN
    ARITH_TAC);

val NAT_ODD = store_thm("NAT_ODD",
 ``!a. bool (ODD a) = acl2_oddp (nat a)``,
    RW_TAC std_ss [acl2_oddp_def,GSYM NAT_EVEN,bool_def,TRUTH_REWRITES,not_def,
    	   ite_def,EVEN_ODD]);

val int_mul_lem = store_thm("int_mul_lem",
``!i. ( ?c. i * 8 = c * 16) = ~(i % 2 = 1)``,
    GEN_TAC THEN `!c. (i * 8 = c * 16) = (i = c * 2)` by ARITH_TAC THEN
    ASM_REWRITE_TAC [] THEN POP_ASSUM (K ALL_TAC) THEN
    EQ_TAC THEN STRIP_TAC THENL [
    	   ALL_TAC,
	   Q.EXISTS_TAC `int_div i 2`] THEN
    FULL_SIMP_TAC int_ss [] THEN
    ARITH_TAC);

val zip_nat_0 = store_thm("zip_nat_0",
  `` zip (nat (0)) = not nil ``,
REWRITE_TAC[zip_def,ite_def,TRUTH_REWRITES] THEN
RW_TAC std_ss[] THEN1
(RW_TAC std_ss[fmap_encodeTheory.not_nil]) THEN
RW_TAC std_ss[GSYM sexpTheory.int_def] THEN
RW_TAC std_ss[nat_def] THEN
RW_TAC std_ss[GSYM INT_THMS] THEN
RW_TAC std_ss[translateTheory.BOOL_T,fmap_encodeTheory.not_nil]);
val RAT_OF_NUM_LEQ_0 = store_thm("RAT_OF_NUM_LEQ_0",
``!n. 0 <= &n``,
	Induct_on `n` THEN1
	PROVE_TAC[RAT_LEQ_REF] THEN
	REWRITE_TAC[RAT_OF_NUM] THEN
	ASSUME_TAC RAT_LES_01 THEN
	ASSUME_TAC (SPECL [``1:rat``, ``&n:rat``] RAT_0LES_0LEQ_ADD) THEN
	REWRITE_TAC[RAT_1, RAT_0] THEN
	REWRITE_TAC[rat_leq_def] THEN
	PROVE_TAC[RAT_ADD_COMM] );
(*-----------------------------*)
(*-----------------------------*)
val rat_of_num_suc_neq_0 = store_thm("rat_of_num_suc_neq_0",
  ``!a. rat_of_num (SUC a) <> 0``,
RW_TAC int_ss[]
THEN ONCE_REWRITE_TAC[boolTheory.EQ_SYM_EQ]
THEN MATCH_MP_TAC ratTheory.RAT_LES_IMP_NEQ
THEN ASSUME_TAC (ONCE_REWRITE_RULE[] (SPECL[``1``,``&a:rat``] RAT_0LES_0LEQ_ADD))
THEN FULL_SIMP_TAC std_ss[RAT_OF_NUM_LEQ_0,RAT_LES_01]
THEN RW_TAC std_ss[ADD1,GSYM RAT_ADD_NUM_CALCULATE]
THEN ONCE_REWRITE_TAC[RAT_ADD_COMM]
THEN RW_TAC int_ss[]);
(*-----------------------------*)
val rat_of_int_neq_0 = store_thm("rat_of_int_neq_0",
  ``!a. (0 < a) ==>
  	rat_of_int (&a) <> 0``,
GEN_TAC
THEN RW_TAC std_ss[]
THEN REWRITE_TAC[rat_of_int_def]
THEN FULL_SIMP_TAC std_ss[intExtensionTheory.INT_NE_IMP_LTGT]
THEN DEP_REWRITE_TAC[intExtensionTheory.INT_ABS_CALCULATE_POS]
THEN RW_TAC int_ss[]
THEN ONCE_REWRITE_TAC[boolTheory.EQ_SYM_EQ]
THEN MATCH_MP_TAC ratTheory.RAT_LES_IMP_NEQ
THEN Cases_on `a`
THEN1 (FULL_SIMP_TAC arith_ss[])
THEN ASSUME_TAC (ONCE_REWRITE_RULE[] (SPECL[``1``,``&n:rat``] RAT_0LES_0LEQ_ADD))
THEN FULL_SIMP_TAC std_ss[RAT_OF_NUM_LEQ_0,RAT_LES_01]
THEN RW_TAC std_ss[ADD1,GSYM RAT_ADD_NUM_CALCULATE]
THEN ONCE_REWRITE_TAC[RAT_ADD_COMM]
THEN RW_TAC int_ss[]);
(*-----------------------------*)
val rat_of_int_suc_neq_0 = store_thm("rat_of_int_suc_neq_0",
  ``!a. rat_of_int (&SUC a) <> 0``,
GEN_TAC
THEN REWRITE_TAC[rat_of_int_def]
THEN FULL_SIMP_TAC std_ss[intExtensionTheory.INT_NE_IMP_LTGT]
THEN DEP_REWRITE_TAC[intExtensionTheory.INT_ABS_CALCULATE_POS]
THEN RW_TAC int_ss[]
THEN RW_TAC std_ss[rat_of_num_suc_neq_0]);
(*-----------------------------*)
val rat_minv_div1 = store_thm("rat_minv_div1",
  ``!a (b:rat). (a <> 0) ==>
  	(((1 / a) * b) = (b / a))``,
RW_TAC std_ss[]
THEN ONCE_REWRITE_TAC[RAT_MUL_COMM]
THEN DEP_REWRITE_TAC[GSYM rat_minv_inv]
THEN ONCE_REWRITE_TAC[boolTheory.EQ_SYM_EQ]
THEN RW_TAC std_ss[]
THEN MATCH_MP_TAC EQ_SYM
THEN DEP_REWRITE_TAC[RAT_RDIV_EQ]
THEN RW_TAC std_ss[]
THEN ONCE_REWRITE_TAC[GSYM RAT_MUL_ASSOC]
THEN DEP_REWRITE_TAC[ratTheory.RAT_MUL_LINV]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[ratTheory.RAT_MUL_RID]);

(*-----------------------------*)
val rat_minv_div = store_thm("rat_minv_div",
  ``!r1 (r2:rat). (r1 <> 0) /\ (r2 <> 0) ==>
  	((1 / (r1 * r2)) = (1 / r1) * (1 / r2))``,
RW_TAC std_ss[]
THEN MATCH_MP_TAC EQ_SYM
THEN DEP_REWRITE_TAC[RAT_RDIV_EQ]
THEN REWRITE_TAC[ratTheory.RAT_NO_ZERODIV_NEG]
THEN RW_TAC std_ss[]
THEN MP_TAC(REWRITE_RULE[](SPECL[``(r1):rat``,``((r2):rat)``] RAT_MUL_COMM))
THEN RW_TAC std_ss[]
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[RAT_MUL_ASSOC]
THEN ONCE_REWRITE_TAC[RAT_MUL_COMM]
THEN RW_TAC std_ss[RAT_MUL_ASSOC]
THEN DEP_REWRITE_TAC[GSYM rat_minv_inv]
THEN ONCE_REWRITE_TAC[boolTheory.EQ_SYM_EQ]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[GSYM RAT_MUL_ASSOC]
THEN MP_TAC(REWRITE_RULE[](SPECL[``rat_minv r2``,``(r2:rat)``] RAT_MUL_COMM))
THEN RW_TAC std_ss[]
THEN ONCE_ASM_REWRITE_TAC[]
THEN DEP_REWRITE_TAC[ratTheory.RAT_MUL_RINV ]
THEN ONCE_REWRITE_TAC[boolTheory.EQ_SYM_EQ]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[ratTheory.RAT_MUL_RID]
THEN DEP_REWRITE_TAC[ratTheory.RAT_MUL_RINV ]
THEN ONCE_REWRITE_TAC[boolTheory.EQ_SYM_EQ]
THEN RW_TAC std_ss[]);
(*-----------------------------*)
val acl2_FACT_equiv_FACT_int = store_thm("acl2_FACT_equiv_FACT_int",
  ``!a. acl2_FACT (int &a) = int (&FACT a)``,
Induct
THEN1 (ONCE_REWRITE_TAC[acl2_FACT_def,FACT]
      THEN ONCE_REWRITE_TAC[GSYM nat_def]
      THEN ONCE_REWRITE_TAC[zip_nat_0]
      THEN ONCE_REWRITE_TAC[fmap_encodeTheory.not_nil]
      THEN REWRITE_TAC[TRUTH_REWRITES])
THEN ONCE_REWRITE_TAC[acl2_FACT_def,FACT]
THEN ONCE_REWRITE_TAC[zip_int_SUC_nil]
THEN REWRITE_TAC[GSYM INT_THMS]
THEN ONCE_REWRITE_TAC[translateTheory.INT_GT]
THEN (ONCE_REWRITE_TAC[prove(``!a. 0 < int_of_num (SUC a)``, RW_TAC int_ss[integerTheory.INT] )])
THEN REWRITE_TAC[translateTheory.BOOL_T,TRUTH_REWRITES]
THEN RW_TAC int_ss[integerTheory.INT]
THEN REWRITE_TAC[integerTheory.INT_SUB_CALCULATE]
THEN REWRITE_TAC[GSYM integerTheory.INT_ADD_ASSOC]
THEN RW_TAC int_ss[]
THEN RW_TAC std_ss[GSYM INT_THMS]
THEN REWRITE_TAC[GSYM integerTheory.INT]
THEN ONCE_REWRITE_TAC[GSYM integerRingTheory.int_calculate]
THEN RW_TAC int_ss[integerTheory.INT_MUL_COMM]);
(*-----------------------------*)
val reciprocal_mult = store_thm("reciprocal_mult",
  ``!a b. (reciprocal (mult (int &SUC a) 
       	  	      (int &SUC b)) =  
       	   mult (reciprocal (int &SUC a)) 
	        (reciprocal (int &SUC b)))``,
RW_TAC std_ss[]
THEN REWRITE_TAC [GSYM rat_int_cov]
THEN DEP_REWRITE_TAC[rat_reciprocal]
THEN REWRITE_TAC[GSYM RAT_THMS]
THEN DEP_REWRITE_TAC[rat_reciprocal]
THEN RW_TAC std_ss[]
THEN1 (REWRITE_TAC[ratTheory.RAT_NO_ZERODIV_NEG]
      THEN STRIP_TAC 
      THEN1 (REWRITE_TAC[rat_of_int_suc_neq_0])
      THEN REWRITE_TAC[rat_of_int_suc_neq_0])
THEN1 (REWRITE_TAC[rat_of_int_suc_neq_0])
THEN1 (REWRITE_TAC[rat_of_int_suc_neq_0])
THEN DEP_REWRITE_TAC[rat_minv_inv]
THEN REWRITE_TAC[rat_of_int_suc_neq_0]
THEN RW_TAC std_ss[]
THEN1 (REWRITE_TAC[ratTheory.RAT_NO_ZERODIV_NEG]
      THEN STRIP_TAC 
      THEN1 (REWRITE_TAC[rat_of_int_suc_neq_0])
      THEN REWRITE_TAC[rat_of_int_suc_neq_0])
THEN DEP_REWRITE_TAC[rat_minv_div]
THEN REWRITE_TAC[rat_of_int_suc_neq_0]);
(*--------------------------------------------*)
val reciprocal_mult_1 = store_thm("reciprocal_mult_1",
  ``!a b. (0 < b) ==>
       	  (reciprocal (mult (int &SUC a) 
       	  	      (int &b)) =  
       	   mult (reciprocal (int &SUC a)) 
	        (reciprocal (int &b)))``,
RW_TAC std_ss[]
THEN REWRITE_TAC [GSYM rat_int_cov]
THEN DEP_REWRITE_TAC[rat_reciprocal]
THEN REWRITE_TAC[GSYM RAT_THMS]
THEN DEP_REWRITE_TAC[rat_reciprocal]
THEN RW_TAC std_ss[]
THEN1 (REWRITE_TAC[ratTheory.RAT_NO_ZERODIV_NEG]
      THEN STRIP_TAC 
      THEN1 (REWRITE_TAC[rat_of_int_suc_neq_0])
      THEN DEP_REWRITE_TAC[ rat_of_int_neq_0 ]
      THEN RW_TAC std_ss[])
THEN1 (REWRITE_TAC[rat_of_int_suc_neq_0])
THEN1 (DEP_REWRITE_TAC[ rat_of_int_neq_0 ]
      THEN RW_TAC std_ss[])
THEN DEP_REWRITE_TAC[rat_minv_inv]
THEN REWRITE_TAC[rat_of_int_suc_neq_0]
THEN RW_TAC std_ss[]
THEN1 (REWRITE_TAC[ratTheory.RAT_NO_ZERODIV_NEG]
      THEN STRIP_TAC 
      THEN1 (REWRITE_TAC[rat_of_int_suc_neq_0])
      THEN DEP_REWRITE_TAC[ rat_of_int_neq_0 ]
      THEN RW_TAC std_ss[])
THEN1 (DEP_REWRITE_TAC[ rat_of_int_neq_0 ]
      THEN RW_TAC std_ss[])
THEN DEP_REWRITE_TAC[rat_minv_div]
THEN DEP_REWRITE_TAC[rat_of_int_suc_neq_0,rat_of_int_neq_0]
THEN RW_TAC std_ss[]);
(*--------------------------------------------*)
val FACT_gt_0 = store_thm("FACT_gt_0",
  ``!a. 0 < FACT a``,
Induct
THEN1 RW_TAC std_ss[FACT]
THEN  RW_TAC std_ss[FACT]
THEN MATCH_MP_TAC arithmeticTheory.LESS_MULT2
THEN RW_TAC arith_ss[]);
(*--------------------------------------------*)
val rat_int_equi_num = store_thm("rat_int_equi_num",
  ``!a. rat (&a) = int (&a)  ``,
GEN_TAC
THEN RW_TAC std_ss[translateTheory.rat_def,int_def]
THEN RW_TAC std_ss[cpx_def]
THEN1 (RW_TAC std_ss[sexpTheory.rat_def,GSYM ratTheory.RAT_OF_NUM_CALCULATE])
THEN RW_TAC std_ss[GSYM rat_of_int_eq_rat]
THEN RW_TAC std_ss[rat_0_eq_rat_of_int0]);
(*--------------------------------------------*)
val rat_of_num_FACT_neq_0 = store_thm("rat_of_num_FACT_neq_0",
  ``!a. &FACT a <> 0``,
Induct
THEN1 (RW_TAC std_ss[FACT]
      THEN RW_TAC std_ss[ratTheory.RAT_1_NOT_0])
THEN RW_TAC std_ss[FACT]
THEN RW_TAC std_ss[GSYM ratTheory.RAT_MUL_NUM_CALCULATE]
THEN RW_TAC std_ss[ratTheory.RAT_NO_ZERODIV_NEG]
THEN RW_TAC std_ss[rat_of_num_suc_neq_0]);
(*--------------------------------------------*)
val acl2_FACT_int_reciprocal = store_thm("acl2_FACT_int_reciprocal",
  ``!a. (reciprocal (acl2_FACT (int (&a))) = (  rat (1 / (&FACT a))))  ``,
Induct
THEN1 (ONCE_REWRITE_TAC[acl2_FACT_def]
      THEN ONCE_REWRITE_TAC[GSYM nat_def]
      THEN ONCE_REWRITE_TAC[zip_nat_0]
      THEN ONCE_REWRITE_TAC[fmap_encodeTheory.not_nil]
      THEN REWRITE_TAC[TRUTH_REWRITES]
      THEN REWRITE_TAC[nat_def]
      THEN REWRITE_TAC[GSYM rat_eq_int_1]
      THEN DEP_REWRITE_TAC[rat_reciprocal]
      THEN STRIP_TAC THEN1 (RW_TAC std_ss rat_rewrites  THEN ARITH_TAC)
      THEN REWRITE_TAC[FACT]
      THEN DEP_REWRITE_TAC[rat_minv_inv] 
      THEN (RW_TAC std_ss rat_rewrites  THEN ARITH_TAC))
THEN ONCE_REWRITE_TAC[acl2_FACT_def,FACT]
THEN ONCE_REWRITE_TAC[zip_int_SUC_nil]
THEN REWRITE_TAC[GSYM INT_THMS]
THEN ONCE_REWRITE_TAC[translateTheory.INT_GT]
THEN (ONCE_REWRITE_TAC[prove(``!a. 0 < int_of_num (SUC a)``, RW_TAC int_ss[integerTheory.INT] )])
THEN REWRITE_TAC[translateTheory.BOOL_T,TRUTH_REWRITES]
THEN RW_TAC int_ss[integerTheory.INT]
THEN REWRITE_TAC[integerTheory.INT_SUB_CALCULATE]
THEN REWRITE_TAC[GSYM integerTheory.INT_ADD_ASSOC]
THEN RW_TAC int_ss[]
THEN REWRITE_TAC[acl2_FACT_equiv_FACT_int]
THEN RW_TAC int_ss[GSYM integerTheory.INT]
THEN DEP_REWRITE_TAC[reciprocal_mult_1]
THEN RW_TAC std_ss[FACT_gt_0]
THEN DEP_REWRITE_TAC[GSYM acl2_FACT_equiv_FACT_int]
THEN ONCE_ASM_REWRITE_TAC[]
THEN REWRITE_TAC[GSYM rat_int_equi_num]
THEN DEP_REWRITE_TAC[rat_reciprocal]
THEN REWRITE_TAC[rat_of_num_suc_neq_0]
THEN DEP_REWRITE_TAC[rat_minv_inv]
THEN REWRITE_TAC[rat_of_num_suc_neq_0]
THEN RW_TAC std_ss[GSYM RAT_THMS]
THEN DEP_REWRITE_TAC[GSYM rat_minv_div]
THEN ONCE_REWRITE_TAC[boolTheory.EQ_SYM_EQ]
THEN RW_TAC std_ss[rat_of_num_suc_neq_0,rat_of_num_FACT_neq_0]
THEN RW_TAC std_ss[GSYM ratTheory.RAT_MUL_NUM_CALCULATE]
THEN RW_TAC std_ss[RAT_MUL_COMM]);
(*--------------------------------*)
val minus_1_eq_acl2_minus = store_thm("minus_1_eq_acl2_minus",
  ``!a. acl2_minus_1 (int &a) = rat (minus_1 a)``,
Cases
THEN1 (RW_TAC std_ss[acl2_minus_1_def,minus_1_def]
      THEN REWRITE_TAC[GSYM nat_def]
      THEN RW_TAC std_ss[GSYM NAT_EVEN]
      THEN RW_TAC std_ss[translateTheory.BOOL_T]
      THEN REWRITE_TAC[ite_def]
      THEN REWRITE_TAC[TRUTH_REWRITES]
      THEN REWRITE_TAC[nat_def]
      THEN REWRITE_TAC[rat_eq_int_1])
THEN RW_TAC std_ss[acl2_minus_1_def,minus_1_def]
THEN1 (REWRITE_TAC[GSYM nat_def]
      THEN RW_TAC std_ss[GSYM NAT_EVEN]
      THEN RW_TAC std_ss[translateTheory.BOOL_T]
      THEN REWRITE_TAC[ite_def]
      THEN REWRITE_TAC[TRUTH_REWRITES]
      THEN REWRITE_TAC[nat_def]
      THEN REWRITE_TAC[rat_eq_int_1])
THEN REWRITE_TAC[GSYM nat_def]
THEN RW_TAC std_ss[GSYM NAT_EVEN]
THEN REWRITE_TAC[ite_def]
THEN REWRITE_TAC[TRUTH_REWRITES]
THEN RW_TAC std_ss[RAT_UNARY_MINUS]
THEN REWRITE_TAC[nat_def]
THEN REWRITE_TAC[rat_eq_int_1]);
(*--------------------------------*)

val minus_exp_ratr_equiv = store_thm("minus_exp_ratr_equiv",
  ``!x m. ~(x = 0) ==> 
       (rat (minus_1 m * (exp_ratr x (&m) / &FACT m)) =
        mult (acl2_minus_1 (nat m))
             (mult (reciprocal (acl2_FACT (nat m))) 
                   (acl2_expt (rat x) (nat m))))``,
RW_TAC std_ss[]
THEN RW_TAC std_ss[RAT_THMS]
THEN REWRITE_TAC[nat_def]
THEN RW_TAC std_ss[acl2_FACT_int_reciprocal]
THEN REWRITE_TAC[nat_def]
THEN DEP_REWRITE_TAC[GSYM exp_ratr_thm]
THEN ONCE_REWRITE_TAC[boolTheory.EQ_SYM_EQ]
THEN RW_TAC std_ss[]
THEN ONCE_REWRITE_TAC[boolTheory.EQ_SYM_EQ]
THEN RW_TAC std_ss[GSYM RAT_THMS]
THEN RW_TAC std_ss[minus_1_eq_acl2_minus]
THEN RW_TAC std_ss[GSYM RAT_THMS]
THEN ONCE_REWRITE_TAC[RAT_MUL_COMM]
THEN DEP_REWRITE_TAC[rat_minv_div1]
THEN RW_TAC std_ss[rat_of_num_FACT_neq_0 ]);

(*-----------------------------*)
val rat_mult_lemma1 = store_thm("rat_mult_lemma1",
  ``!a b c:rat. (0 <> c) ==> (a * b / c = a * (b / c))``,
RW_TAC std_ss[]
THEN MP_TAC (ISPECL [``c:rat``,``b:rat``] (GSYM rat_minv_div1))
THEN RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[GSYM rat_minv_inv]
THEN DEP_ONCE_REWRITE_TAC[GSYM rat_minv_div1]
THEN DEP_REWRITE_TAC[GSYM rat_minv_inv]
THEN RW_TAC std_ss[]
THEN ONCE_REWRITE_TAC[RAT_MUL_ASSOC]
THEN MP_TAC (ISPECL [``rat_minv c``,``a:rat``] (RAT_MUL_COMM))
THEN RW_TAC std_ss[]);
(*--------------------*)
val expt_macl_equi_acl2_expt_macl = store_thm("expt_macl_equi_acl2_expt_macl",
  ``!x m n. (x <> 0) ==>
       (rat (expt_macl x m n) = 
       acl2_expt_macl (rat x) (nat m) (nat n))``,
GEN_TAC
THEN GEN_TAC
THEN Induct
THEN1 (ONCE_REWRITE_TAC[expt_macl_def,acl2_expt_macl_def]
      THEN RW_TAC int_ss [nat_def,GSYM INT_THMS,nat_def,GSYM RAT_THMS,ite_def,TRUTH_REWRITES,zip_def,
    	   INTEGERP_INT,GSYM int_def,integerTheory.int_exp,FIX_INT,
	   integerTheory.INT_ADD_CALCULATE,FIX_NUM]
     THEN DEP_REWRITE_TAC [rat_mult_lemma1]
     THEN DEP_REWRITE_TAC[minus_exp_ratr_equiv]
     THEN RW_TAC std_ss[nat_def]
     THEN ONCE_REWRITE_TAC[boolTheory.EQ_SYM_EQ]
     THEN RW_TAC std_ss[rat_of_num_FACT_neq_0])
THEN RW_TAC std_ss[]
THEN ONCE_REWRITE_TAC[expt_macl_def,acl2_expt_macl_def]
THEN REWRITE_TAC[numTheory.NOT_SUC]
THEN REWRITE_TAC[prim_recTheory.LESS_0]
THEN REWRITE_TAC[nat_def,zip_int_SUC_nil]
THEN REWRITE_TAC[FIX_NUM]
THEN REWRITE_TAC[GSYM rat_eq_int]
THEN REWRITE_TAC[GSYM RAT_THMS]
THEN FULL_SIMP_TAC std_ss[]
THEN REWRITE_TAC [BOOL_F]
THEN REWRITE_TAC[ite_def]
THEN REWRITE_TAC[rat_eq_int]
THEN REWRITE_TAC[GSYM INT_THMS]
THEN ONCE_REWRITE_TAC[translateTheory.INT_GT]
THEN (ONCE_REWRITE_TAC[prove(``!a. 0 < int_of_num (SUC n')``, RW_TAC int_ss[integerTheory.INT] )])
THEN REWRITE_TAC [BOOL_T]
THEN FULL_SIMP_TAC std_ss[TRUTH_REWRITES]
THEN REWRITE_TAC[ratTheory.RAT_ADD_NUM_CALCULATE]
THEN REWRITE_TAC[integerRingTheory.int_rewrites]
THEN RW_TAC std_ss[minus_1_eq_acl2_minus]
THEN REWRITE_TAC[RAT_ADD]
THEN DEP_REWRITE_TAC[minus_exp_ratr_equiv]
THEN REWRITE_TAC[integerTheory.INT]
THEN RW_TAC int_ss[]
THEN REWRITE_TAC[integerTheory.int_sub]
THEN REWRITE_TAC [GSYM integerTheory.INT_ADD_ASSOC]
THEN RW_TAC int_ss[integerTheory.INT_ADD_RINV]
THEN RW_TAC std_ss[nat_def]
THEN RW_TAC std_ss[ADD_COMM]
THEN RW_TAC std_ss[minus_1_eq_acl2_minus]);

val _ = export_theory();
